SystemOrganization addCategory: #'Moose-Core'!

!String methodsFor: '*moose-core' stamp: 'stephane.ducasse 6/29/2008 18:34'!
mooseName

	^ self  asSymbol! !

!String methodsFor: '*moose-core' stamp: 'tg 7/27/2010 12:37'!
sourceText 
	"This is more of a hack to deal with the situation in which exporters populate sourceAnchor directly with 
	a path to a file rather than with a proper SourceAnchor object"
	self flag: 'possibly try to infer a file from the current string and get the source from there'.
	^ self ! !

!Symbol methodsFor: '*moose-core' stamp: 'simon.denier 4/1/2009 15:11'!
asSortBlock

	^ [:a :b | (self value: a) <= (self value: b)]! !

Announcement subclass: #MooseEntityAnnouncement
	instanceVariableNames: 'entity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-Core'!

MooseEntityAnnouncement subclass: #MooseEntityAdded
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-Core'!

!MooseEntityAnnouncement methodsFor: 'accessing' stamp: 'tg 11/17/2009 00:26'!
entity
	^ entity! !

!MooseEntityAnnouncement methodsFor: 'accessing' stamp: 'tg 11/17/2009 00:26'!
entity: anObject
	entity := anObject! !

MooseEntityAnnouncement subclass: #MooseEntityRemoved
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-Core'!

MooseEntityAnnouncement subclass: #MooseEntityRenamed
	instanceVariableNames: 'oldName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-Core'!

!MooseEntityRenamed methodsFor: 'accessing' stamp: 'tg 12/18/2009 17:06'!
oldName
	^ oldName! !

!MooseEntityRenamed methodsFor: 'accessing' stamp: 'tg 12/18/2009 17:06'!
oldName: anObject
	oldName := anObject! !

RBBlockLintRule subclass: #FAMIXMetaModelClassesNotDeclaredInFameRule
	instanceVariableNames: 'metaModelClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-Core'!

!FAMIXMetaModelClassesNotDeclaredInFameRule methodsFor: 'running' stamp: 'tg 8/10/2010 16:00'!
checkClass: aContext
	|class  pragmas |
	class := aContext selectedClass.

	(self metaModelClasses includes: class instanceSide)
		ifTrue: [
			pragmas := Pragma allNamed: #MSEClass:super: in: class.
			pragmas ifEmpty: [
				class isMeta ifTrue: [ result addClass: class ].
			^ self ].
		pragmas size > 1 ifTrue: [ result addClass: class. ^ self ].
	]! !

!FAMIXMetaModelClassesNotDeclaredInFameRule methodsFor: 'accessing' stamp: 'simondenier 4/19/2010 15:44'!
group
	^ 'FAMIX'! !

!FAMIXMetaModelClassesNotDeclaredInFameRule methodsFor: 'accessing' stamp: 'simondenier 4/19/2010 15:44'!
metaModelClasses
	"return all classes that have to be checked in this rule"
	^ metaModelClasses ifNil: [metaModelClasses := MooseEntity withAllSubclasses].! !

!FAMIXMetaModelClassesNotDeclaredInFameRule methodsFor: 'accessing' stamp: 'simondenier 4/19/2010 16:46'!
name

	^ 'A metamodel class is not properly Fame-described by a <MSEClass:super:> pragma'! !

!FAMIXMetaModelClassesNotDeclaredInFameRule methodsFor: 'accessing' stamp: 'simondenier 4/19/2010 16:09'!
rationale

	^ 'check if a metamodel class is properly declared using a <MSEClass:super:> pragma. Additionally, this pragma should be in a #annotation class-side method, although this is not enforced. Default Moose tools are resilient with respect to metamodel descriptions, and accept as metamodel classes any subclass of MooseEntity. This rule enforces that all such classes are properly described in Fame, ensuring proper use by strict tools.'! !

!FAMIXMetaModelClassesNotDeclaredInFameRule methodsFor: 'running' stamp: 'TudorGirba 10/19/2011 20:33'!
resultClass

	^ RBClassEnvironment ! !

RBBlockLintRule subclass: #FAMIXMetaModelClassesShouldNotOverrideRule
	instanceVariableNames: 'metaModelClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-Core'!

!FAMIXMetaModelClassesShouldNotOverrideRule methodsFor: 'running' stamp: 'cyrille.delaunay 11/30/2009 16:20'!
checkClass: aContext
	|class  |
	class := aContext selectedClass .
	
	(self metaModelClasses includes: class) 
		ifTrue: [
			self selectorsThatShouldNotBeOverriden do: [:each |
			(class includesSelector: each)
				ifTrue: [
					result addClass: class  selector: each
					]. 
			].
		].! !

!FAMIXMetaModelClassesShouldNotOverrideRule methodsFor: 'accessing' stamp: 'cyrille.delaunay 12/1/2009 10:41'!
group
	^ 'FAMIX'! !

!FAMIXMetaModelClassesShouldNotOverrideRule methodsFor: 'accessing' stamp: 'cyrille.delaunay 11/30/2009 16:12'!
metaModelClasses
	"return all classes that have to be checked in this rule"
	^ metaModelClasses ifNil: [metaModelClasses := MooseEntity withAllSubclasses].! !

!FAMIXMetaModelClassesShouldNotOverrideRule methodsFor: 'accessing' stamp: 'cyrille.delaunay 11/30/2009 16:01'!
name

	^ 'A metamodel class override a method that it should not override'! !

!FAMIXMetaModelClassesShouldNotOverrideRule methodsFor: 'accessing' stamp: 'cyrille.delaunay 11/30/2009 16:06'!
rationale

	^ 'check if a metamodel class (FAMIXEntity and all its subclasses) override some methods that it should not override. Those methods are specified by RBFAMIXMetaModelClassesShouldNotOverrideRule >> selectorsThatShouldNotBeOverriden'! !

!FAMIXMetaModelClassesShouldNotOverrideRule methodsFor: 'accessing' stamp: 'tg 8/10/2010 15:50'!
selectorsThatShouldNotBeOverriden

	^ #(#mooseName #printString #mooseDisplayString)! !

RBBlockLintRule subclass: #FAMIXMetaModelClassesShouldOverrideRule
	instanceVariableNames: 'metaModelClasses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-Core'!

!FAMIXMetaModelClassesShouldOverrideRule methodsFor: 'running' stamp: 'cyrille.delaunay 12/1/2009 10:41'!
checkClass: aContext
	|class  |
	class := aContext selectedClass .
	
	(self metaModelClasses includes: class) 
		ifTrue: [
			
			self selectorsThatShouldBeOverriden do: [:each |
			(class includesSelector: each)
				ifFalse: [
					result addClass: class  into: each .
					]. 
			].
		].! !

!FAMIXMetaModelClassesShouldOverrideRule methodsFor: 'accessing' stamp: 'cyrille.delaunay 12/1/2009 10:27'!
group
	^ 'FAMIX'! !

!FAMIXMetaModelClassesShouldOverrideRule methodsFor: 'accessing' stamp: 'cyrille.delaunay 11/30/2009 16:12'!
metaModelClasses
	"return all classes that have to be checked in this rule"
	^ metaModelClasses ifNil: [metaModelClasses := MooseEntity withAllSubclasses]
! !

!FAMIXMetaModelClassesShouldOverrideRule methodsFor: 'accessing' stamp: 'simondenier 4/19/2010 16:50'!
name

	^ 'A metamodel class does not override a method that it should override'! !

!FAMIXMetaModelClassesShouldOverrideRule methodsFor: 'accessing' stamp: 'cyrille.delaunay 11/30/2009 16:34'!
rationale

	^ 'check if a metamodel class (FAMIXEntity and all its subclasses) doesnt override some methods that it should override. Those methods are specified by RBFAMIXMetaModelClassesShouldOverrideRule >> selectorsThatShouldBeOverriden'! !

!FAMIXMetaModelClassesShouldOverrideRule methodsFor: 'running' stamp: 'TudorGirba 10/19/2011 20:33'!
resultClass 
	^ RBMultiEnvironment ! !

!FAMIXMetaModelClassesShouldOverrideRule methodsFor: 'accessing' stamp: 'cyrille.delaunay 11/30/2009 16:24'!
selectorsThatShouldBeOverriden

	^ #(#mooseNameOn: #printOn: #shortPrintOn:)! !

!SystemDictionary methodsFor: '*Moose-Core' stamp: 'stephane.ducasse 6/24/2008 09:32'!
absoluteName
	"Answer an environment independent (and therefore truely unique) name."

	^ 'Smalltalk'! !

!SystemDictionary methodsFor: '*Moose-Core' stamp: 'stephane.ducasse 10/1/2008 11:50'!
mooseName
	
	^ #Smalltalk ! !

!RBVariableNode methodsFor: '*Moose-Core' stamp: 'stephane.ducasse 1/20/2009 18:51'!
isSuper

	^ token value asString = 'super'! !

FMPragmaProcessor subclass: #MoosePragmaProcessor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-Core'!

!MoosePragmaProcessor methodsFor: 'as yet unclassified' stamp: 'simon.denier 5/19/2009 23:59'!
processClass: aClass 
	| pragmas meta className superclassName |

	className := aClass name.
	superclassName := aClass superclass name.
	pragmas := Pragma 
		allNamed: #MSEClass:super:
		in: aClass class.
	pragmas isEmpty ifFalse: [ 
		className := pragmas first argumentAt: 1.
		superclassName := pragmas first argumentAt: 2.
	].

	"the description for the class"
	meta := FM3MetaDescription new.
	meta name: className asString.
	superclassDict 
		at: meta
		put: superclassName.
	meta setImplementingClass: aClass.

	pragmas isEmpty ifFalse: [
		(Pragma 
			inMethod: pragmas first method
			named: #abstract) ifNotNil: [ meta isAbstract: true ].

		(Pragma inMethod: pragmas first method named: #package:)
			ifNotNil: [
				packMetaDict at: meta put: ((Pragma inMethod: pragmas first method named: #package:) argumentAt: 1) asString ].
	].

	elements add: meta.
	classDict 
		at: aClass
		put: meta.
	aClass methodDictionary values do: [ :each | self processCompiledMethod: each ].
	self assert: [ meta isKindOf: FM3MetaDescription ].
	^ meta! !

!BlockContext methodsFor: '*moose-core' stamp: 'simon.denier 4/1/2009 15:13'!
asSortBlock

	^ [:a :b | (self value: a) <= (self value: b)]! !

!BlockContext methodsFor: '*moose-core' stamp: 'sd 8/25/2008 18:09'!
cullValue: arguments
	"Evaluates the receiver with as many arguments as requiered."

	self numArgs = 0 ifTrue: [ ^self value ].
	self numArgs = 1 ifTrue: [ ^self value: arguments first ].
	^self valueWithArguments: (arguments  copyFrom: 1 to: self numArgs).! !

!Collection methodsFor: '*Moose-Core' stamp: 'stephane.ducasse 6/22/2008 19:28'!
asMooseGroup
	^ MooseGroup withAll: self! !

!Collection methodsFor: '*Moose-Core' stamp: 'stephane.ducasse 10/20/2008 20:15'!
commonSuperclass
	"Answer the most specific common super class of the receiver's
	elements, returns Object on empty collections."

	| common |
	self isEmpty ifTrue: [ ^Object ].
	common := self anyOne class.
	self do: [ :each |
		Object == common ifTrue: [ ^Object ].
		[ each class includesBehavior: common ] whileFalse: [
			common := common superclass ]].
	^common! !

Collection variableSubclass: #MooseGroupStorage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-Core'!

MooseGroupStorage variableSubclass: #MooseGroupRuntimeStorage
	instanceVariableNames: 'byName elements byType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-Core'!

!MooseGroupRuntimeStorage methodsFor: 'adding' stamp: 'simondenier 4/20/2010 23:40'!
add: anElement 

	| key group |

	key := anElement class.
	group := byType 
		at: key
		ifAbsentPut: [ OrderedCollection new ].
	group add: anElement.
	elements add: anElement.
	^ anElement! !

!MooseGroupRuntimeStorage methodsFor: 'accessing' stamp: 'TudorGirba 11/7/2011 19:47'!
at: uniqueName ifAbsent: exceptionBlock 
	 
	| entity na |
	na := uniqueName asSymbol.
	"look first by name and if not found"
	entity := byName at: na ifAbsent: [nil].
	entity notNil ifTrue: [^entity].
	"iterates over all the elements"
	entity := self
		detect: [:each | na == each mooseName asSymbol]
		ifNone: exceptionBlock.
	entity notNil ifTrue: [byName at: na put: entity].
	^entity! !

!MooseGroupRuntimeStorage methodsFor: 'enumerating' stamp: ' 8/5/08 13:52'!
do: aBlock 
	 
	elements do: aBlock! !

!MooseGroupRuntimeStorage methodsFor: 'accessing' stamp: 'tg 8/5/2010 07:48'!
elements 
	^ elements! !

!MooseGroupRuntimeStorage methodsFor: 'initialize-release' stamp: 'simondenier 4/20/2010 23:40'!
initialize: capacity 
	 
	byType := Dictionary new: 24. 
	byName := IdentityDictionary new: 10000. 
	elements := OrderedCollection new: capacity! !

!MooseGroupRuntimeStorage methodsFor: 'copying' stamp: 'simondenier 4/20/2010 23:40'!
postCopy  
	super postCopy.
	elements := elements copy.
	byName := byName copy.
	byType := byType copy! !

!MooseGroupRuntimeStorage methodsFor: 'removing' stamp: 'simondenier 4/20/2010 23:40'!
remove: anElement ifAbsent: exceptionBlock 
	 
	| key group | 
	key := anElement class. 
	group := byType 
		at: key 
		ifAbsent: [OrderedCollection new]. 
	group remove: anElement ifAbsent: exceptionBlock. 
	byName 
		removeKey: anElement mooseName asSymbol
		ifAbsent: exceptionBlock. 
	elements remove: anElement. 
	^anElement! !

!MooseGroupRuntimeStorage methodsFor: 'removing' stamp: ' 8/5/08 13:52'!
removeAll 
	 
	self initialize: 10000! !

!MooseGroupRuntimeStorage methodsFor: 'enumerating' stamp: 'simondenier 4/20/2010 23:40'!
selectAllWithType: aSmalltalkClass 
	^ byType 
		at: aSmalltalkClass
		ifAbsent: [ OrderedCollection new ]! !

!MooseGroupRuntimeStorage methodsFor: 'accessing' stamp: 'tg 8/5/2010 07:32'!
size 
	^ elements size! !

MooseGroupStorage variableSubclass: #MooseGroupSetupStorage
	instanceVariableNames: 'elements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-Core'!

!MooseGroupSetupStorage methodsFor: 'adding' stamp: ' 8/5/08 13:52'!
add: anElement 
	 
	^elements add: anElement! !

!MooseGroupSetupStorage methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/23/2009 22:46'!
at: uniqueName ifAbsent: exceptionBlock 
	 | s |
	s := uniqueName asSymbol.
	^self 
		detect: [:each | s == each mooseName asSymbol] 
		ifNone: exceptionBlock! !

!MooseGroupSetupStorage methodsFor: 'accessing-sequenceable' stamp: ' 8/5/08 13:52'!
atIndex: index 
	 
	^elements at: index! !

!MooseGroupSetupStorage methodsFor: 'enumerating' stamp: ' 8/5/08 13:52'!
do: aBlock 
	 
	^elements do: aBlock! !

!MooseGroupSetupStorage methodsFor: 'accessing' stamp: ' 8/5/08 13:52'!
elements 
	 
	^self asArray! !

!MooseGroupSetupStorage methodsFor: 'accessing-sequenceable' stamp: ' 8/5/08 13:52'!
first 
	 
	^elements first! !

!MooseGroupSetupStorage methodsFor: 'initialize-release' stamp: 'tg 5/8/2008 14:25'!
initialize 
	 
	elements := OrderedCollection new: 10000! !

!MooseGroupSetupStorage methodsFor: 'initialize-release' stamp: 'tg 5/8/2008 14:25'!
initialize: capacity 
	 
	elements := OrderedCollection new: capacity! !

!MooseGroupSetupStorage methodsFor: 'accessing-sequenceable' stamp: ' 8/5/08 13:52'!
last 
	 
	^elements last! !

!MooseGroupSetupStorage methodsFor: 'copying' stamp: 'tg 4/7/2010 21:12'!
postCopy  
	super postCopy.
	elements := elements copy! !

!MooseGroupSetupStorage methodsFor: 'removing' stamp: ' 8/5/08 13:52'!
remove: anElement ifAbsent: exceptionBlock 
	 
	^elements remove: anElement ifAbsent: exceptionBlock! !

!MooseGroupSetupStorage methodsFor: 'removing' stamp: ' 8/5/08 13:52'!
removeAll 
	 
	self initialize! !

!MooseGroupSetupStorage methodsFor: 'enumerating' stamp: 'tg 11/28/2009 17:48'!
selectAllWithType: aSmalltalkClass 
	^ self select: 
		[ :each | 
		"-- select returns an ArrayList"
		each class = aSmalltalkClass ]! !

!MooseGroupSetupStorage methodsFor: 'accessing' stamp: ' 8/5/08 13:52'!
size 
	 
	^elements size! !

MooseGroupSetupStorage variableSubclass: #MooseGroupTeardownStorage
	instanceVariableNames: 'tally'
	classVariableNames: 'Tombstone'
	poolDictionaries: ''
	category: 'Moose-Core'!

!MooseGroupTeardownStorage methodsFor: 'adding' stamp: ' 8/5/08 13:52'!
add: anElement 
	 
	tally := tally + 1. 
	^elements add: anElement! !

!MooseGroupTeardownStorage methodsFor: 'enumerating' stamp: ' 8/5/08 13:52'!
do: aBlock 
	 
	^elements do: [:each | Tombstone ~~ each ifTrue: [aBlock value: each]]! !

!MooseGroupTeardownStorage methodsFor: 'removing' stamp: ' 8/5/08 13:52'!
remove: anElement ifAbsent: exceptionBlock 
	 
	| index | 
	index := elements 
		findFirst: [:each | anElement = each] 
		ifAbsent: exceptionBlock. 
	elements at: index put: Tombstone. 
	tally := tally - 1. 
	^anElement! !

!MooseGroupTeardownStorage methodsFor: 'accessing' stamp: ' 8/5/08 13:52'!
size 
	 
	^tally! !

!MooseGroupStorage class methodsFor: 'instance creation' stamp: 'TudorGirba 1/30/2011 19:31'!
empty
	^ MooseGroupRuntimeStorage new! !

!MooseGroupStorage class methodsFor: 'instance creation' stamp: ' 8/5/08 13:52'!
new 
	 
	^self basicNew initialize: 1000! !

!MooseGroupStorage class methodsFor: 'instance creation' stamp: ' 8/5/08 13:52'!
new: capacity 
	 
	^self basicNew initialize: capacity! !

!MooseGroupStorage class methodsFor: 'instance creation' stamp: ' 8/5/08 13:52'!
withAll: aCollection 
	" Answer a new instance of this class, 
	whose elements are the elements of aCollection. " 
	 
	| newCollection | 
	newCollection := self new: aCollection size. 
	newCollection addAll: aCollection. 
	^newCollection! !

!MooseGroupStorage methodsFor: 'adding' stamp: ' 8/5/08 13:52'!
add: anElement 
	 
	^self subclassResponsibility! !

!MooseGroupStorage methodsFor: 'accessing' stamp: 'Alexandre.Bergel 4/23/2009 22:40'!
at: uniqueName 
	 
	^self 
		at: uniqueName asSymbol
		ifAbsent: [nil]! !

!MooseGroupStorage methodsFor: 'accessing' stamp: ' 8/5/08 13:52'!
at: uniqueName ifAbsent: exceptionBlock 
	 
	^self subclassResponsibility! !

!MooseGroupStorage methodsFor: 'private' stamp: 'TudorGirba 1/30/2011 19:31'!
becomeKind: elementStorageClass 
	 
	[elementStorageClass includesBehavior: MooseGroupStorage] assert. 
	self class = elementStorageClass 
		ifFalse: [self become: (elementStorageClass withAll: self)]! !

!MooseGroupStorage methodsFor: 'enumerating' stamp: 'stephane.ducasse 5/23/2008 15:41'!
collect: aBlock 
	 
	| newCollection | 
	newCollection := OrderedCollection new: self size. 
	self do: [:each | newCollection add: (aBlock value: each)]. 
	^newCollection! !

!MooseGroupStorage methodsFor: 'enumerating' stamp: ' 8/5/08 13:52'!
do: aBlock 
	 
	self subclassResponsibility! !

!MooseGroupStorage methodsFor: 'accessing' stamp: ' 8/5/08 13:52'!
elements 
	 
	^self subclassResponsibility! !

!MooseGroupStorage methodsFor: 'converting' stamp: 'TudorGirba 1/30/2011 19:31'!
forRemoving 
	 
	self becomeKind: MooseGroupTeardownStorage! !

!MooseGroupStorage methodsFor: 'converting' stamp: 'TudorGirba 1/30/2011 19:31'!
forRuntime 
	 
	self becomeKind: MooseGroupRuntimeStorage! !

!MooseGroupStorage methodsFor: 'converting' stamp: 'TudorGirba 1/30/2011 19:31'!
forSetup 
	 
	self becomeKind: MooseGroupSetupStorage! !

!MooseGroupStorage methodsFor: 'testing' stamp: ' 8/5/08 13:52'!
includesID: mooseID 
	 
	^self anySatisfy: [:each | mooseID == each mooseID]! !

!MooseGroupStorage methodsFor: 'removing' stamp: ' 8/5/08 13:52'!
remove: anElement 
	 
	^self 
		remove: anElement 
		ifAbsent: [anElement]! !

!MooseGroupStorage methodsFor: 'removing' stamp: ' 8/5/08 13:52'!
remove: anElement ifAbsent: exceptionBlock 
	 
	^self subclassResponsibility! !

!MooseGroupStorage methodsFor: 'removing' stamp: ' 8/5/08 13:52'!
removeAll 
	 
	^self subclassResponsibility! !

!MooseGroupStorage methodsFor: 'enumerating' stamp: 'tg 6/23/2008 22:05'!
selectAllWithType: aSmalltalkClass 
	^ self subclassResponsibility! !

!MooseGroupStorage methodsFor: 'accessing' stamp: ' 8/5/08 13:52'!
size 
	 
	^self subclassResponsibility! !

!MooseGroupStorage methodsFor: 'private' stamp: 'stephane.ducasse 5/23/2008 15:41'!
species 
	 
	^OrderedCollection! !

!BlockClosure methodsFor: '*moose-core' stamp: 'sd 8/25/2008 18:09'!
cullValue: arguments
	"Evaluates the receiver with as many arguments as requiered."

	self numArgs = 0 ifTrue: [ ^self value ].
	self numArgs = 1 ifTrue: [ ^self value: arguments first ].
	^self valueWithArguments: (arguments  copyFrom: 1 to: self numArgs).! !

FMImporter subclass: #MSEImporter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-Core'!

!MSEImporter methodsFor: 'as yet unclassified' stamp: 'TudorGirba 1/21/2011 15:23'!
endDocument
	"This method overrides the default FMImporter to allow for dangling references"
	
	self assert: [ stack isEmpty ].
	stack := nil.
	model addAll: elements.! !

!RBProgramNode methodsFor: '*Moose-Core' stamp: 'stephane.ducasse 1/20/2009 18:53'!
isSuper

	^ false! !

!Metaclass methodsFor: '*Moose-Core' stamp: 'stephane.ducasse 6/23/2008 21:36'!
absoluteName
	"Answer an environment independent (and therefore truely unique) name."

	^thisClass absoluteName, ' class'! !

!Metaclass methodsFor: '*Moose-Core' stamp: 'stephane.ducasse 6/29/2008 19:12'!
mooseName

	^ ('Smalltalk::' , self soleInstance name, '_class') asSymbol! !

!Class methodsFor: '*Moose-Core' stamp: 'stephane.ducasse 6/23/2008 21:35'!
absoluteName
	"Answer an environment independent (and therefore truely unique) name."

	^ self name asString! !

!Class methodsFor: '*Moose-Core' stamp: 'stephane.ducasse 9/26/2008 22:28'!
mooseName
	"asnwer the full moose name"

	^ ('Smalltalk::', self name) asSymbol! !

!Class methodsFor: '*Moose-Core' stamp: 'tg 8/28/2010 17:35'!
mooseNameOf: aString
	"utility method for concatenating strings to a basic mooseName"
	^ (self mooseName, '.', aString) asSymbol! !

!Class methodsFor: '*Moose-Core' stamp: 'tg 8/28/2010 17:37'!
mooseNameOfSelf
	^ self mooseNameOf: 'self'! !

!Class methodsFor: '*Moose-Core' stamp: 'tg 8/28/2010 17:37'!
mooseNameOfSuper
	^ self mooseNameOf: 'super'! !

Object subclass: #MooseEntity
	instanceVariableNames: 'mooseID state'
	classVariableNames: 'MooseID'
	poolDictionaries: ''
	category: 'Moose-Core'!

!MooseEntity commentStamp: 'janniklaval 9/28/2011 13:51' prior: 0!
MooseEntity is an abstract entity. Entities should subclass this class.
Any moose entity should answer its mooseID, its mooseName and its mooseModel.

!!!!Extension mechanism

The state instance variable provides a mechanism for extending the state of entities. This is achieved through MooseEntityState. Using this mechanism, a package can extend an entity to add more state. This extension will only be visible when the package is loaded. This is an important mechanism to enable extensibility and modularity. 

For example, if you have YourEntity that subclasses MooseEntity, you can extend it with:

YourEntity>>yourExtendingAttribute
	^ self privateState attributeAt: #yourExtendingAttribute
YourEntity>>yourExtendingAttribute: aValue
	^ self privateState attributeAt: #yourExtendingAttribute put: aValue

(see MooseEntityState for more information)


!!!!Meta descriptions

Entities should also be meta-described in terms of Fame. This is achieved by means of pragmas:

- First, on the class side, you should have a method . For example, YourEntity could have
YourEntity class>>annotation
	<MSEClass: #YourEntity super: #MooseEntity>
	<package: 'YourPackage'>
	<MSEComment: 'The YourEntity Smalltalk class has a correspondent YourEntity meta entity in the Fame world'>

- The pragma <MSEProperty:type:> must be placed in the getter method to denote a Fame property. For example:
YourEntity>>yourExtendingAttribute
	<MSEProperty: #yourExtendingAttribute type: #YourType>
	<MSEComment: 'This is an attribute extended in a different package'>
	^ self privateState attributeAt: #yourExtendingAttribute
	
	
!!!!Important API

- mooseID is an Integer that uniquely identifies this entity within the entire Moose environment. 
	It should not change nor be nil. It is generated automatically during the creation of the MooseEntity.
- mooseModel of an entity is must be an instance of MooseModel. It may be nil if the entity is not part of a model.	
	Each entity belongs to one and only one model, if an entity has not yet been added to a model or if an entity has been removed from a model the mooseModel is undefined, that is it may be nil.
- mooseDescription - returns the corresponding FM3MetaDescription instance
- mooseName - returns a symbol that should qualify the current entity. It does not have to be unique
!

MooseEntity subclass: #MooseAbstractGroup
	instanceVariableNames: 'storage'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-Core'!

!MooseAbstractGroup commentStamp: '<historical>' prior: 0!
AbstractGroup is an entity that offers the basic mechanism for managing multiple entities. It is also the superclass of MooseModel.

It stores the contained entities in a storage variable that points to a MooseGroupStorage strategy.

!

!MooseAbstractGroup class methodsFor: 'meta' stamp: 'TudorGirba 12/4/2011 21:36'!
annotation
	<MSEClass: #AbstractGroup super: #MooseEntity>
	<package: #Moose>
	<abstract>
! !

!MooseAbstractGroup methodsFor: 'set operations' stamp: 'tg 7/30/2009 23:48'!
\ aCollection
	^ self difference: aCollection! !

!MooseAbstractGroup methodsFor: 'adding/removing' stamp: 'simondenier 4/9/2010 11:37'!
add: anItem 

	self entityStorage add: anItem.
	self privateState flushGroups. 
	^ anItem! !

!MooseAbstractGroup methodsFor: 'adding/removing' stamp: 'tg 7/30/2009 20:32'!
addAll: aCollectionOfItems 
	^ self subclassResponsibility! !

!MooseAbstractGroup methodsFor: 'groups' stamp: 'stephane.ducasse 8/18/2008 21:39'!
allModels 
	 
	<navigation: 'All models'> 
	^self allWithType: MooseModel ! !

!MooseAbstractGroup methodsFor: 'public interface' stamp: 'TudorGirba 4/27/2011 22:21'!
allSatisfy: aBlock 
	 
	^self entities allSatisfy: aBlock! !

!MooseAbstractGroup methodsFor: 'groups' stamp: 'TudorGirba 8/30/2011 07:49'!
allWithSubTypesOf: aSmalltalkClass 
	^ self allWithSubTypesOf: aSmalltalkClass ofGroupClass: MooseGroup ! !

!MooseAbstractGroup methodsFor: 'groups' stamp: 'TudorGirba 8/30/2011 07:52'!
allWithSubTypesOf: aSmalltalkClass ofGroupClass:  aGroupSmalltalkClass
	| all |
	all := aSmalltalkClass withAllSubclasses flatCollect: [:each |
		self entityStorage selectAllWithType: each ].
	^ self privateState cacheAt: aSmalltalkClass name
		ifAbsentPut: [
			aGroupSmalltalkClass 
				withAll: all
				withDescription: 'All ' , aSmalltalkClass name asLowercase asEnglishPlural]! !

!MooseAbstractGroup methodsFor: 'groups' stamp: 'TudorGirba 8/30/2011 07:52'!
allWithType: aSmalltalkClass 
	^ self allWithType: aSmalltalkClass ofGroupClass: MooseGroup ! !

!MooseAbstractGroup methodsFor: 'groups' stamp: 'TudorGirba 8/30/2011 07:53'!
allWithType: aSmalltalkClass ofGroupClass: aGroupSmalltalkClass
	^ self privateState 
		cacheAt: aSmalltalkClass name
		ifAbsentPut: [
			aGroupSmalltalkClass 
				withAll: (self entityStorage selectAllWithType: aSmalltalkClass)
				withDescription: 'All ' , aSmalltalkClass name asLowercase asEnglishPlural ]! !

!MooseAbstractGroup methodsFor: 'accessing' stamp: 'TudorGirba 4/27/2011 22:21'!
anyOne
	 
	^self entities anyOne! !

!MooseAbstractGroup methodsFor: 'public interface' stamp: 'TudorGirba 4/27/2011 22:21'!
anySatisfy: aBlock 
	 
	^self entities anySatisfy: aBlock! !

!MooseAbstractGroup methodsFor: 'converting' stamp: 'tg 8/5/2010 09:05'!
asArray 
	 
	^self entityStorage asArray! !

!MooseAbstractGroup methodsFor: 'converting' stamp: 'tg 5/18/2010 20:10'!
asMooseGroup 
	^ self ! !

!MooseAbstractGroup methodsFor: 'converting' stamp: 'tg 8/5/2010 20:50'!
asOrderedCollection 
	^ self entityStorage asOrderedCollection! !

!MooseAbstractGroup methodsFor: 'converting' stamp: 'tg 8/5/2010 20:50'!
asSet 
	^ self entityStorage asSet! !

!MooseAbstractGroup methodsFor: 'converting' stamp: 'tg 8/5/2010 20:50'!
asSortedCollection
	^ self entityStorage asSortedCollection! !

!MooseAbstractGroup methodsFor: 'converting' stamp: 'simon.denier 9/21/2010 15:48'!
asSortedCollection: aSortBlock
	^ self entityStorage asSortedCollection: aSortBlock ! !

!MooseAbstractGroup methodsFor: 'accessing' stamp: 'tg 7/30/2009 15:27'!
at: anIndex
	^ self entities at: anIndex! !

!MooseAbstractGroup methodsFor: 'enumerating' stamp: 'tg 7/30/2009 20:32'!
collect: aBlock 
	^ self entities collect: aBlock! !

!MooseAbstractGroup methodsFor: 'enumerating' stamp: 'TudorGirba 4/27/2011 22:22'!
collectAsSet: aBlock
	^ self entities collectAsSet: aBlock! !

!MooseAbstractGroup methodsFor: 'accessing' stamp: 'tg 12/6/2009 01:59'!
commonSuperclass 
	^ self entityStorage commonSuperclass! !

!MooseAbstractGroup methodsFor: 'enumerating' stamp: ' 8/5/08 13:52'!
contains: aBlock 
	 
	^self entities contains: aBlock! !

!MooseAbstractGroup methodsFor: 'enumerating' stamp: ' 8/5/08 13:52'!
count: aBlock 
	 
	| count | 
	count := 0. 
	self do: [:each | (aBlock value: each) ifTrue: [count := count + 1]]. 
	^count! !

!MooseAbstractGroup methodsFor: 'enumerating' stamp: ' 8/5/08 13:52'!
detect: aBlock 
	 
	^self entities detect: aBlock! !

!MooseAbstractGroup methodsFor: 'enumerating' stamp: ' 8/5/08 13:52'!
detect: aBlock ifNone: anotherBlock 
	 
	^self entities detect: aBlock ifNone: anotherBlock! !

!MooseAbstractGroup methodsFor: 'set operations' stamp: 'tg 7/30/2009 20:33'!
difference: aGroup 
	self subclassResponsibility! !

!MooseAbstractGroup methodsFor: 'enumerating' stamp: 'TudorGirba 4/27/2011 22:57'!
do: aBlock 
	 
	^self entityStorage do: aBlock! !

!MooseAbstractGroup methodsFor: 'enumerating' stamp: 'tg 8/2/2010 00:40'!
do: elementBlock separatedBy: separatorBlock
	^ self entities do: elementBlock separatedBy: separatorBlock! !

!MooseAbstractGroup methodsFor: 'enumerating' stamp: 'tg 1/19/2010 23:27'!
doWithIndex: aBlockClosure 
	self entities doWithIndex: aBlockClosure ! !

!MooseAbstractGroup methodsFor: 'entity collection' stamp: 'tg 7/30/2009 23:45'!
entities
	^ self entityStorage elements! !

!MooseAbstractGroup methodsFor: 'entity collection' stamp: ' 8/5/08 13:52'!
entities: aCollection 
	 
	self entityStorage removeAll. 
	self addAll: aCollection	"	aCollection do: [:each | self addEntity: each ]."! !

!MooseAbstractGroup methodsFor: 'entity collection' stamp: ' 8/5/08 13:52'!
entitiesDo: aBlock 
	 
	^self entityStorage do: aBlock	"self entityDictionary keysAndValuesDo: [ :key :group | 
		group do: aBlock 
	]."! !

!MooseAbstractGroup methodsFor: 'public interface' stamp: ' 8/5/08 13:52'!
entityNamed: aSymbol 
	 
	^self 
		entityNamed: aSymbol 
		ifAbsent: [nil]! !

!MooseAbstractGroup methodsFor: 'public interface' stamp: 'simondenier 11/30/2009 15:16'!
entityNamed: aMooseName ifAbsent: aBlock 
	^ self entityStorage at: aMooseName ifAbsent: aBlock! !

!MooseAbstractGroup methodsFor: 'public interface' stamp: 'TudorGirba 9/23/2011 14:36'!
entityNamed: aMooseName ifAbsent: aBlock ifPresent: anotherBlock
	| entity |
	entity := self entityStorage at: aMooseName ifAbsent: [nil].
	^ entity isNil 
		ifTrue: [aBlock value]
		ifFalse: [anotherBlock value: entity]! !

!MooseAbstractGroup methodsFor: 'public interface' stamp: 'TudorGirba 9/23/2011 14:31'!
entityNamed: aMooseName ifAbsentPut: aValue 
	^ self entityNamed: aMooseName ifAbsent: [self add: aValue]! !

!MooseAbstractGroup methodsFor: 'private' stamp: ' 8/5/08 13:52'!
entityStorage 
	 
	^storage! !

!MooseAbstractGroup methodsFor: 'testing' stamp: 'TudorGirba 4/27/2011 22:21'!
equalsTo: aCollection
	^ self entities equalsTo: aCollection! !

!MooseAbstractGroup methodsFor: 'accessing' stamp: ' 8/5/08 13:52'!
first 
	 
	^self entities first! !

!MooseAbstractGroup methodsFor: 'enumerating' stamp: 'tg 8/12/2009 01:49'!
first: n
	^ self entities first: n! !

!MooseAbstractGroup methodsFor: 'enumerating' stamp: 'tg 5/12/2010 09:50'!
flatCollect: aBlock 
	^ (self entities flatCollect: aBlock) asMooseGroup! !

!MooseAbstractGroup methodsFor: 'enumerating' stamp: 'TudorGirba 9/9/2011 20:26'!
flatCollectAsSet: aBlock 
	^ (self entities flatCollectAsSet: aBlock) asMooseGroup! !

!MooseAbstractGroup methodsFor: 'enumerating' stamp: ' 8/5/08 13:52'!
groupedBy: aBlock 
	 
	^self entities groupedBy: [:each | (aBlock value: each) ifNil: [#'<nil>']]! !

!MooseAbstractGroup methodsFor: 'testing' stamp: ' 8/5/08 13:52'!
includes: anEntity 
	 
	^self entities includes: anEntity! !

!MooseAbstractGroup methodsFor: 'testing' stamp: 'tg 11/19/2010 18:37'!
includesAllOf: aCollection 
	^ self entities includesAllOf: aCollection! !

!MooseAbstractGroup methodsFor: 'entity collection' stamp: ' 8/5/08 13:52'!
includesID: elementID 
	 
	^self entityStorage includesID: elementID! !

!MooseAbstractGroup methodsFor: 'initialize-release' stamp: 'TudorGirba 1/30/2011 19:31'!
initialize 
	 
	super initialize.
	storage := MooseGroupStorage empty! !

!MooseAbstractGroup methodsFor: 'enumerating' stamp: ' 8/5/08 13:52'!
inject: neutral into: aBinaryBlock 
	 
	^self entities inject: neutral into: aBinaryBlock! !

!MooseAbstractGroup methodsFor: 'enumerating' stamp: 'tg 11/28/2009 00:20'!
insertInto: aSequenceableCollection from: anInteger to: anotherInteger 
	^ self entities insertInto: aSequenceableCollection from: anInteger to: anotherInteger! !

!MooseAbstractGroup methodsFor: 'set operations' stamp: 'tg 7/30/2009 20:33'!
intersect: aGroup 
	self subclassResponsibility! !

!MooseAbstractGroup methodsFor: 'testing' stamp: 'tg 5/8/2008 14:51'!
isCollection 
	 
	^true! !

!MooseAbstractGroup methodsFor: 'testing' stamp: 'tg 11/29/2009 17:18'!
isEmpty 
	 
	^self entityStorage isEmpty! !

!MooseAbstractGroup methodsFor: 'accessing' stamp: ' 8/5/08 13:52'!
last 
	 
	^self entities last! !

!MooseAbstractGroup methodsFor: 'enumerating' stamp: 'tg 8/12/2009 01:49'!
last: n
	^ self entities last: n! !

!MooseAbstractGroup methodsFor: 'accessing' stamp: ' 8/5/08 13:52'!
mooseModel: anObject 
	 
	self shouldNotImplement! !

!MooseAbstractGroup methodsFor: 'testing' stamp: ' 8/5/08 13:52'!
notEmpty 
	 
	^self entities notEmpty! !

!MooseAbstractGroup methodsFor: 'accessing' stamp: 'FabrizioPerin 10/10/2011 11:43'!
numberOfItems 
	<MSEProperty: #numberOfItems type: #Number>
	<MSEComment: 'The total number of items in the group'>
	
	^self size! !

!MooseAbstractGroup methodsFor: 'enumerating' stamp: ' 8/5/08 13:52'!
occurrencesOf: anObject 
	 
	^self entities occurrencesOf: anObject! !

!MooseAbstractGroup methodsFor: 'copying' stamp: 'tg 4/7/2010 21:11'!
postCopy  
	super postCopy.
	storage := storage copy. ! !

!MooseAbstractGroup methodsFor: 'printing' stamp: 'tg 7/24/2010 22:42'!
printOn: aStream 
	 
	super printOn: aStream. 
	aStream nextPut: $(. 
	aStream nextPutAll: self size printString. 
	aStream nextPut: $)! !

!MooseAbstractGroup methodsFor: 'enumerating' stamp: ' 8/5/08 13:52'!
reject: aBlock 
	 
	^self entities reject: aBlock! !

!MooseAbstractGroup methodsFor: 'adding/removing' stamp: ' 8/5/08 13:52'!
remove: anItem 
	 
	^self subclassResponsibility! !

!MooseAbstractGroup methodsFor: 'adding/removing' stamp: ' 8/5/08 13:52'!
removeAll: aCollection 
	 
	^self subclassResponsibility! !

!MooseAbstractGroup methodsFor: 'entity collection' stamp: 'jannik.laval 11/9/2009 12:47'!
removeEntity: anEntity 
	 
	^self entityStorage remove: anEntity! !

!MooseAbstractGroup methodsFor: 'accessing' stamp: 'Alexandre.Bergel 8/17/2009 08:23'!
second 
	 
	^self entities second! !

!MooseAbstractGroup methodsFor: 'enumerating' stamp: ' 8/5/08 13:52'!
select: aBlock 
	 
	^self entities select: aBlock! !

!MooseAbstractGroup methodsFor: 'enumerating' stamp: 'simon.denier 3/30/2009 19:41'!
selectFirst: anInteger 
	 
	self flag: #patched. "VW uses sliceTo:, which is a copyFrom:To: with checked indices. Not the case here"
	^self class withAll: (self entities copyFrom: 1 to: anInteger)! !

!MooseAbstractGroup methodsFor: 'enumerating' stamp: 'TudorGirba 7/5/2011 09:34'!
selectWithNameSimilarTo: anEntity
	^ self select: [:each | 
		each ~= anEntity and: [
			(each name pairsDistanceFrom: anEntity name) > 0.5]]! !

!MooseAbstractGroup methodsFor: 'accessing' stamp: 'TudorGirba 4/27/2011 22:57'!
size	 
	^ self entityStorage size! !

!MooseAbstractGroup methodsFor: 'accessing' stamp: 'Alexandre.Bergel 8/17/2009 08:23'!
third 
	 
	^self entities third! !

!MooseAbstractGroup methodsFor: 'set operations' stamp: 'AlexandreBergel 3/24/2011 19:44'!
union: aGroup 

	self subclassResponsibility

	"| result | 
	result := MooseGroup withAll: (self entities asSet union: aGroup entities asSet). 
	result description: self description , '  and ' , aGroup description. 
	^result"! !

!MooseAbstractGroup methodsFor: 'enumerating' stamp: 'tg 9/9/2009 02:27'!
withIndexDo: aBlockClosure 
	self entities withIndexDo: aBlockClosure ! !

MooseAbstractGroup subclass: #MooseGroup
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-Core'!

!MooseGroup commentStamp: 'StephaneDucasse 11/13/2011 21:22' prior: 0!
MooseGroup adds on top of an abstract group the ability to change the type of a group when we change the entities inside. This is determined via class names.

For example, a XYZGroup handles a group of XYZ entities. Thus, "MooseGroup with: XYZ new" will return a XYZGroup. The type changing behavior also works at runtime. Thus, "MooseGroup new add: XYZ" will also return a XYZGroup.

The goal of this abstraction is to provide a home for behavior that is specific to groups of entities. For example, a visualization that makes sense for a group of XYZ entities will become a method in the XYZGroup class.!

!MooseGroup class methodsFor: 'instance creation' stamp: 'tg 8/10/2010 15:53'!
annotation
	<MSEClass: #Group super: #MooseAbstractGroup>
	<package: #Moose>
! !

!MooseGroup class methodsFor: 'instance creation' stamp: ' 8/5/08 13:52'!
new 
	 
	^self new: 5! !

!MooseGroup class methodsFor: 'instance creation' stamp: ' 8/5/08 13:52'!
new: capacity 
	 
	^self basicNew initialize: capacity! !

!MooseGroup class methodsFor: 'instance creation' stamp: 'tg 11/9/2009 16:41'!
with: anEntity 
	 
	^anEntity isNil 
		ifTrue: [self new] 
		ifFalse: [self withAll: (Array with: anEntity)]! !

!MooseGroup class methodsFor: 'instance creation' stamp: ' 8/5/08 13:52'!
with: anEntity withDescription: aDescription 
	 
	^(self with: anEntity) description: aDescription! !

!MooseGroup class methodsFor: 'instance creation' stamp: 'tg 12/6/2009 01:57'!
withAll: collection 

	| common wantedClass wantedType |
	^ self = MooseGroup
		ifTrue: [ 
			common := collection commonSuperclass.
			wantedType := (common name, 'Group') asSymbol.
			wantedClass := self allSubclasses detect: [:each | each name = wantedType ] ifNone: [MooseGroup] .
			self withKnownType: wantedClass withAll: collection ]
		ifFalse: [ self withKnownType: self withAll: collection ]! !

!MooseGroup class methodsFor: 'instance creation' stamp: ' 8/5/08 13:52'!
withAll: entities withDescription: aDescription 
	 
	^(self withAll: entities) description: aDescription! !

!MooseGroup class methodsFor: 'instance creation' stamp: ' 8/5/08 13:52'!
withDescription: aDescription 
	 
	^self new description: aDescription! !

!MooseGroup class methodsFor: 'instance creation' stamp: 'tg 12/6/2009 01:53'!
withKnownType: anSTClass withAll: collection 
	^ (anSTClass new: collection size) initializeWithAll: collection! !

!MooseGroup methodsFor: 'adding/removing' stamp: 'tg 7/30/2009 23:48'!
, aGroup
	^ (self copy) 
		addAll: aGroup; 
		yourself! !

!MooseGroup methodsFor: 'adding/removing' stamp: 'simondenier 4/9/2010 11:38'!
add: anElement 
	 
	super add: anElement. 
	self updateTypeAccordingToEntities.
	^ anElement ! !

!MooseGroup methodsFor: 'adding/removing' stamp: ' 8/5/08 13:52'!
addAll: collection 
	 
	self entityStorage addAll: collection. 
	self updateTypeAccordingToEntities! !

!MooseGroup methodsFor: 'adding/removing' stamp: ' 8/5/08 13:52'!
addLast: anEntity 
	 
	^self add: anEntity! !

!MooseGroup methodsFor: 'public interface' stamp: 'cyrille.delaunay 4/1/2010 16:44'!
average: aSymbolOrBlock 
	 
	^ (self sum: aSymbolOrBlock) / self size! !

!MooseGroup methodsFor: 'private' stamp: 'tg 8/10/2010 15:59'!
changeTypeTo: aSmalltalkClass
	| group | 
	self class == aSmalltalkClass ifTrue: [^ self].

	group := aSmalltalkClass withDescription: self description. 
	group addAll: self entities. 
	self become: group! !

!MooseGroup methodsFor: 'private' stamp: 'tg 5/8/2008 14:35'!
changeTypeToDefaultType
	self changeTypeTo: MooseGroup! !

!MooseGroup methodsFor: 'adding/removing' stamp: 'tg 7/22/2010 13:31'!
collect: aBlock 

	| resultCollection result | 
	resultCollection := self entities collect: aBlock. 
	result := MooseGroup withAll: resultCollection. 
	^ result! !

!MooseGroup methodsFor: 'private' stamp: 'tg 11/29/2009 17:19'!
commonMetaDescription 
	 
	^self entityStorage commonSuperclass! !

!MooseGroup methodsFor: 'public interface' stamp: 'tg 1/19/2010 23:24'!
copyFrom: startIndex to: endIndex 
	| resultCollection result | 
	resultCollection := self entities copyFrom: startIndex to: endIndex.
	result := self species withAll: resultCollection. 
	^ result	! !

!MooseGroup methodsFor: 'set operations' stamp: 'tg 7/30/2009 21:04'!
difference: aGroup 
	 
	| result | 
	result := self class withAll: (self entities difference: aGroup entities). 
	result description: self description , '  subtracted with ' , aGroup description. 
	^result! !

!MooseGroup methodsFor: 'public interface' stamp: ' 8/5/08 13:52'!
distributionOverAGroupOfGroups: aGroupOfGroups 
	 
	| distribution | 
	distribution := 0. 
	aGroupOfGroups 
		do: 
			[:eachReferenceGroup |  
			| intersection | 
			intersection := self intersect: eachReferenceGroup. 
			distribution := distribution 
				+ (intersection size / eachReferenceGroup size)]. 
	^distribution! !

!MooseGroup methodsFor: 'public interface' stamp: ' 8/5/08 13:52'!
encapsulationOfAGroupOfGroups: aGroupOfGroups 
	 
	| encapsulation | 
	self isEmpty ifTrue: [^0]. 
	encapsulation := 0. 
	aGroupOfGroups 
		do: 
			[:eachReferenceGroup |  
			| intersection | 
			intersection := self intersect: eachReferenceGroup. 
			encapsulation := intersection size / eachReferenceGroup size 
				* (intersection size / self size) + encapsulation]. 
	^encapsulation! !

!MooseGroup methodsFor: 'public interface' stamp: ' 8/5/08 13:52'!
indexOf: anEntity 
	 
	^self entities indexOf: anEntity! !

!MooseGroup methodsFor: 'initialize-release' stamp: ' 8/5/08 13:52'!
initialize: capacity 
	 
	self initialize. 
	self description: 'Group'! !

!MooseGroup methodsFor: 'initialize-release' stamp: 'tg 11/9/2009 16:43'!
initializeWithAll: aCollection
	self entityStorage addAll: aCollection.! !

!MooseGroup methodsFor: 'set operations' stamp: 'tg 7/30/2009 23:46'!
intersect: aGroup 
	 
	| result | 
	result := self class withAll: (self entities intersection: aGroup entities). 
	result description: self description , '  intersected with ' , aGroup description. 
	^result! !

!MooseGroup methodsFor: 'public interface' stamp: 'TudorGirba 7/16/2011 00:00'!
max: aSymbolOrBlock 
	 
	^self 
		inject: (aSymbolOrBlock value: self first) 
		into: [:max :each | max max: (aSymbolOrBlock value: each)]! !

!MooseGroup methodsFor: 'public interface' stamp: 'TudorGirba 7/16/2011 00:01'!
min: aSymbolOrBlock 
	 
	^self 
		inject: (aSymbolOrBlock value: self first) 
		into: [:min :each | min min: (aSymbolOrBlock value: each)]! !

!MooseGroup methodsFor: 'printing' stamp: 'tg 8/31/2010 10:22'!
mooseDisplayStringOn: stream
	stream 
			nextPutAll: self description; 
			space; 
			nextPut: $(; 
			print: self size. 
"			space. 
		self isEmpty ifTrue: [stream nextPutAll: 'items']. 
""		self size = 1 ifTrue: [stream nextPutAll: self first class name]. 
		self size > 1 ifTrue: [stream nextPutAll: self first class name asEnglishPlural]. 
"		stream nextPut: $)! !

!MooseGroup methodsFor: 'accessing' stamp: ' 8/5/08 13:52'!
mooseModel 
	 
	^self isEmpty 
		ifTrue: [nil] 
		ifFalse: [self first mooseModel]! !

!MooseGroup methodsFor: 'accessing' stamp: 'jannik.laval 5/21/2010 08:11'!
name

	^self privateState attributeAt: #privateDescription ifAbsent:[#group]
	! !

!MooseGroup methodsFor: 'public interface' stamp: 'tg 10/26/2010 15:35'!
noneSatisfy: aBlock 
	 
	^self entities noneSatisfy: aBlock! !

!MooseGroup methodsFor: 'printing' stamp: 'AlexandreBergel 3/3/2011 19:13'!
printOn: aStream 

	aStream 
		nextPutAll: self description; 
		space; 
		nextPut: $(; 
		print: self size; 
		space. 
	self isEmpty ifTrue: [aStream nextPutAll: 'items']. 
	self size = 1 ifTrue: [aStream nextPutAll: self anyOne class name]. 
	self size > 1 ifTrue: [aStream nextPutAll: self anyOne class name asEnglishPlural]. 
	aStream nextPut: $).
	
"	aStream nextPut: Character space.
	aStream nextPut: $(.
	self entities do: [:element | aStream print: element] separatedBy: [aStream space].
	aStream nextPut: $)
"	! !

!MooseGroup methodsFor: 'adding/removing' stamp: ' 8/5/08 13:52'!
readStream 
	 
	^self entities readStream! !

!MooseGroup methodsFor: 'public interface' stamp: 'Alexandre.Bergel 6/4/2009 15:14'!
reject: aBlock 
	 
	| resultCollection result | 
	resultCollection := self entities reject: aBlock. 
	result := self species withAll: resultCollection. 
	^result! !

!MooseGroup methodsFor: 'adding/removing' stamp: ' 8/5/08 13:52'!
remove: anItem 
	 
	self removeEntity: anItem. 
	self updateTypeAccordingToEntities! !

!MooseGroup methodsFor: 'adding/removing' stamp: ' 8/5/08 13:52'!
removeAll: collection 
	 
	collection do: [:each | self removeEntity: each]. 
	self updateTypeAccordingToEntities! !

!MooseGroup methodsFor: 'public interface' stamp: ' 8/5/08 13:52'!
select: aBlock 
	 
	| resultCollection result | 
	resultCollection := self entities select: aBlock. 
	result := self species withAll: resultCollection. 
	^result! !

!MooseGroup methodsFor: 'public interface' stamp: 'tg 8/4/2009 16:45'!
selectByExpression: anExpression 
	^ self select: anExpression 
"	| resultCollection | 
	resultCollection := self entities select: [:each | anExpression value: each value: self]. 
	^self species 
		withAll: resultCollection 
		withDescription: 
			self description , ' selected by ' , anExpression printString"! !

!MooseGroup methodsFor: 'public interface' stamp: 'simon.denier 9/21/2010 16:55'!
selectCover: aFraction forMetric: aSymbolOrBlock
	"select biggest entities which cover aFraction of the metric property for the whole group. Useful to easily check the 80/20 rule for example:
		self selectCover: 0.80 forMetric: #numberOfLinesOfCode
	returns the entities which cover 80% of the code base in number of lines of code"
	
	| cutValue sorted tops sum i |
	self assert: (aFraction >= 0 and: [aFraction <= 1]).
	cutValue := (self sum: aSymbolOrBlock) * aFraction.
	sorted := self asSortedCollection: [:a :b | (aSymbolOrBlock value: a) > (aSymbolOrBlock value: b)].
	tops := OrderedCollection new.
	sum := 0. i := 1.
	[ sum < cutValue and: [ i <= self size ]]
		whileTrue: [
			tops add: (sorted at: i).
			sum := sum + (aSymbolOrBlock value: (sorted at: i)).
			i := i + 1].
	^ MoosePropertyGroup withAll: tops from: self using: aSymbolOrBlock! !

!MooseGroup methodsFor: 'public interface' stamp: 'simon.denier 9/21/2010 16:38'!
selectEightyCoverForMetric: aSymbolOrBlock

	^ self selectCover: 0.80 forMetric: aSymbolOrBlock ! !

!MooseGroup methodsFor: 'public interface' stamp: 'simon.denier 9/21/2010 17:24'!
selectTop: aFraction forMetric: aSymbolOrBlock
	"select top xx entities with highest metric value in the group. Useful to easily check the 80/20 rule.
	For example:
		self selectTop: 0.20 forMetric: #numberOfLinesOfCode
	returns the top 20% entities in number of lines of code"
	
	| topsSize sorted tops cutValue i |
	self assert: (aFraction >= 0 and: [aFraction <= 1]).
	topsSize := (self size * aFraction) ceiling. "number of entities to select"
	topsSize isZero ifTrue: [ ^ MooseGroup new ].
	sorted := self asSortedCollection: [:a :b | (aSymbolOrBlock value: a) > (aSymbolOrBlock value: b)].
	tops := sorted copyFrom: 1 to: topsSize.

	"We check whether next elements should be retrieved, because their value matches the one of the last element which made the cut."
	cutValue := aSymbolOrBlock value: (sorted at: topsSize).
	i := topsSize + 1.
	[ i <= sorted size and: [ (aSymbolOrBlock value: (sorted at: i)) = cutValue ]]
		whileTrue: [
			tops add: (sorted at: i).
			i := i + 1 ].
	^ MoosePropertyGroup withAll: tops from: self using: aSymbolOrBlock! !

!MooseGroup methodsFor: 'public interface' stamp: 'AlexandreBergel 3/3/2011 19:26'!
selectTopTwentyForMetric: aSymbolOrBlock
	"Return the 20% top most methods for the metric aSymbolOrBlock"

	^ self selectTop: 0.20 forMetric: aSymbolOrBlock! !

!MooseGroup methodsFor: 'public interface' stamp: 'TudorGirba 11/25/2010 23:35'!
sorted: aBlock 
	 
	self entities: (self entities sorted: aBlock)! !

!MooseGroup methodsFor: 'public interface' stamp: ' 8/5/08 13:52'!
sum: aSymbolOrBlock 
	 
	^self 
		inject: 0 
		into: [:sum :each | sum + (aSymbolOrBlock value: each)]! !

!MooseGroup methodsFor: 'properties' stamp: ' 8/5/08 13:52'!
sumOfPropertyNamed: aPropertyName 
	 
	^self 
		inject: 0 
		into: 
			[:sum :each |  
			sum 
				+ 
					(each 
						propertyNamed: aPropertyName 
						ifNil: [0])]! !

!MooseGroup methodsFor: 'set operations' stamp: 'tg 7/30/2009 23:46'!
union: aGroup 
	 
	| result | 
	result := self class withAll: (self entities asSet union: aGroup entities asSet). 
	result description: self description , '  and ' , aGroup description. 
	^result! !

!MooseGroup methodsFor: 'private' stamp: 'tg 12/6/2009 01:46'!
updateTypeAccordingToEntities
	| common wantedType class |
	common := self commonMetaDescription.
	wantedType := (common name, 'Group') asSymbol.
	self name = wantedType ifTrue: [ ^ self ].
	class := MooseAbstractGroup allSubclasses 
		detect: [ :each | each name == wantedType ]
		ifNone: [ ^ self changeTypeToDefaultType ].
	self changeTypeTo: class! !

MooseGroup subclass: #MoosePropertyGroup
	instanceVariableNames: 'originalGroup propertySymbolOrBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-Core'!

!MoosePropertyGroup commentStamp: 'StephaneDucasse 11/13/2011 21:24' prior: 0!
MoosePropertyGroup is a selection over a group. The selection is specify via a predicate expressed as a symbol or a block. The original group is available using the message originalGroup.

Instance Variables:
	originalGroup	<MooseGroup>
	propertySymbolOrBlock!

!MoosePropertyGroup class methodsFor: 'instance creation' stamp: 'simon.denier 9/21/2010 16:54'!
withAll: aCollection from: aMooseGroup using: aSymbolOrBlock

	^ (self withAll: aCollection) originalGroup: aMooseGroup; property: aSymbolOrBlock; yourself! !

!MoosePropertyGroup methodsFor: 'accessing' stamp: 'simon.denier 9/21/2010 16:56'!
asMooseGroup

	^ MooseGroup withAll: self! !

!MoosePropertyGroup methodsFor: 'accessing' stamp: 'simon.denier 9/21/2010 16:52'!
originalGroup
	^ originalGroup! !

!MoosePropertyGroup methodsFor: 'accessing' stamp: 'simon.denier 9/21/2010 16:52'!
originalGroup: anObject
	originalGroup := anObject! !

!MoosePropertyGroup methodsFor: 'accessing' stamp: 'FabrizioPerin 10/10/2011 15:58'!
property
	<MSEProperty: #property type: #String>
	<MSEComment: 'Description of the property'>
	
	^ propertySymbolOrBlock! !

!MoosePropertyGroup methodsFor: 'accessing' stamp: 'simon.denier 9/21/2010 16:53'!
property: anObject
	propertySymbolOrBlock := anObject! !

!MoosePropertyGroup methodsFor: 'accessing' stamp: 'FabrizioPerin 10/10/2011 11:41'!
propertyRatio
	<MSEProperty: #propertyRatio type: #Number>
	<MSEComment: 'Fraction represented by this group compared to originalGroup with respect to the property'>
	
	^ (self propertyTotal / self propertyTotalOriginal) asFloat ! !

!MoosePropertyGroup methodsFor: 'accessing' stamp: 'FabrizioPerin 10/10/2011 11:40'!
propertyTotal
	<MSEProperty: #propertyTotal type: #Number>
	<MSEComment: 'Sum of values computed for the property in this group'>

	^ self sum: self property! !

!MoosePropertyGroup methodsFor: 'accessing' stamp: 'FabrizioPerin 10/10/2011 11:39'!
propertyTotalOriginal
	<MSEProperty: #propertyTotalOriginal type: #Number>
	<MSEComment: 'Sum of values computed for the property in the original group'>

	^ self originalGroup sum: self property ! !

!MoosePropertyGroup methodsFor: 'accessing' stamp: 'TudorGirba 12/18/2011 02:01'!
sizeOriginal
	<MSEProperty: #sizeOriginal type: #Number>
	<MSEComment: 'Size of the original group'>
	
	^ self originalGroup size! !

!MoosePropertyGroup methodsFor: 'accessing' stamp: 'FabrizioPerin 10/10/2011 11:38'!
sizeRatio
	<MSEProperty: #sizeRatio type: #Number>
	<MSEComment: 'Fraction represented by this group compared to originalGroup'>	

	^ (self size / self originalGroup size) asFloat! !

MooseAbstractGroup subclass: #MooseModel
	instanceVariableNames: 'sourceLanguage name'
	classVariableNames: 'MostRecentOwner'
	poolDictionaries: ''
	category: 'Moose-Core'!

MooseModel class
	instanceVariableNames: 'mostRecentOwner rootModel metaTower'!

!MooseModel commentStamp: 'TudorGirba 1/21/2011 10:49' prior: 0!
MooseModel is a special group that is used for manipulating an entire model.!

MooseModel class
	instanceVariableNames: 'mostRecentOwner rootModel metaTower'!

!MooseModel class methodsFor: 'meta' stamp: 'tg 8/10/2010 15:53'!
annotation
	<MSEClass: #Model super: #MooseAbstractGroup>
	<package: #Moose>
! !

!MooseModel class methodsFor: 'import-export' stamp: 'tg 8/5/2009 11:38'!
export: aModel to: aStream
	self export: aModel withMetamodel: self meta to: aStream! !

!MooseModel class methodsFor: 'import-export' stamp: 'cyrille.delaunay 11/23/2009 10:17'!
export: aModel withMetamodel: aMetamodel to: aStream 
	| tower repository |
	tower := FMCompleteTower new.
	tower metaMetamodel: aMetamodel metamodel.
	tower metamodel: aMetamodel.
	tower model: (repository := (FMRepository with: aMetamodel) addAll: aModel entities).
	tower model exportOn: aStream! !

!MooseModel class methodsFor: 'import-export' stamp: 'simon.denier 4/21/2009 20:56'!
exportMetamodel: aMetamodel to: aStream

	aMetamodel exportOn: aStream
"
	| tower |
	tower := FMCompleteTower new.
	tower metamodel: aMetamodel.

	tower metamodel exportOn: aStream
"! !

!MooseModel class methodsFor: 'import-export' stamp: 'simon.denier 4/21/2009 20:56'!
exportMetamodelTo: aStream

	self exportMetamodel: self meta to: aStream
! !

!MooseModel class methodsFor: 'meta' stamp: 'TudorGirba 2/12/2011 00:26'!
generateClassesFrom: aCollection
	"I generate the implementation for some meta-described classes. aCollection need to contain the full set of meta-described classes so that the metamodel is complete. Warning, part of classes will be overwritten."
	
	|tower generator|
	tower := MooseModel metaBuilder: aCollection withProcessor: MoosePragmaProcessor new.
	generator := FMDefaultCodeGenerator new.
	generator visit: tower metamodel.
	generator previewChanges.! !

!MooseModel class methodsFor: 'meta' stamp: 'TudorGirba 2/12/2011 00:26'!
generateClassesFrom: aCollection inPackage: aString
	"I generate the implementation for some meta-described classes. aCollection need to contain the full set of meta-described classes so that the metamodel is complete. aString is the name of the FM3 package for which elements should be generated. In other words, only elements belonging to FM3 package 'aString' will be generated, not all elements of the metamodel in aCollection.

	This method is for incremental generation of metamodels, especially Famix extensions.
	MooseModel generateClassesFrom: MooseModel metamodelClasses inPackage: 'NewExtension'
	"
	
	|tower generator fm3Package |
	tower := MooseModel metaBuilder: aCollection withProcessor: MoosePragmaProcessor new.
	generator := FMDefaultCodeGenerator new.
	fm3Package := tower metamodel packageNamed: aString.
	generator acceptFamePackage: fm3Package.
	self flag: #classExtensionNotSupported. "currently the generator does not handle extension to other packages - cf #acceptFamePackage:"
	generator previewChanges.! !

!MooseModel class methodsFor: 'import-export' stamp: 'tg 8/5/2009 11:39'!
importFrom: aStream
	^ self importFrom: aStream withMetamodel: self meta! !

!MooseModel class methodsFor: 'import-export' stamp: 'cyrille.delaunay 11/19/2009 16:14'!
importFrom: aStream filteredBy: anImportingContext 
	^self 
		importFrom: aStream
		withMetamodel: self meta
		filteredBy: anImportingContext! !

!MooseModel class methodsFor: 'import-export' stamp: 'tg 5/25/2009 22:55'!
importFrom: aStream withMetamodel: aMetamodel

	| tower importer |
	tower := FMCompleteTower new.
	tower metamodel addAll: aMetamodel elements.
	importer := MSEImporter new.
	importer repository: tower model.
	importer stream: aStream.
	importer run.
	tower model updateCache.
	^ tower model! !

!MooseModel class methodsFor: 'import-export' stamp: 'cyrille.delaunay 12/15/2009 16:00'!
importFrom: aStream withMetamodel: aMetamodel filteredBy: anImportingContext

	| tower importer famixElementNames importerFilter |
	
	"famixElementNames := OrderedCollection new.
	anImportingContext entityKindsToBeExtracted do: [:each | famixElementNames add: 'FAMIX.',each asString ].
	anImportingContext  shouldImportMethodBody 
		ifTrue: [famixElementNames add: 'FAMIX.Parameter'.
			anImportingContext shouldImportAccess ifTrue:[famixElementNames add:'FAMIX.Reference']]."
		
	famixElementNames := anImportingContext fullNamesOfEntitiesToBeExtracted .
	
	tower := FMCompleteTower new.
	tower metamodel addAll: aMetamodel elements.
	importer := MSEImporter new.
	importer repository: tower model.
	importer stream: aStream.
	importerFilter := FMImporterFilter onClient: importer withFilter: famixElementNames.
	importerFilter  run.
	tower model updateCache.
	^ tower model! !

!MooseModel class methodsFor: 'import-export' stamp: 'simon.denier 4/21/2009 20:56'!
importMetamodelFrom: aStream

	| tower generator |
	tower := FMCompleteTower new.
	tower metamodel importStream: aStream.
	generator := FMDefaultCodeGenerator new.
	generator visit: tower metamodel.
	generator previewChanges. "keep shift pressed to see the changes"
! !

!MooseModel class methodsFor: 'menu' stamp: 'TudorGirba 4/29/2011 22:35'!
menuCommandOn: aBuilder
	<worldMenu>
	(aBuilder item: #Moose)
		order: 6.0; 
		withSeparatorAfter;
		icon: MooseIcons mooseIcon! !

!MooseModel class methodsFor: 'meta' stamp: 'simon.denier 4/17/2009 19:16'!
meta
	"
	self meta.
	self resetMeta.
	self metaTower.
	"
	
	^self metaTower metamodel! !

!MooseModel class methodsFor: 'meta' stamp: 'TudorGirba 2/12/2011 00:26'!
metaBuilder: aCollectionOfClasses 
	"I take as parameter a collection of classes described with Fame pragmas"

	^ self metaBuilder: aCollectionOfClasses withProcessor: MoosePragmaProcessor new! !

!MooseModel class methodsFor: 'meta' stamp: 'simon.denier 4/17/2009 19:09'!
metaBuilder: aCollectionOfClasses withProcessor: aPragmaProcessor
	"I take as parameters a collection of classes described with Fame pragmas and a processor for Fame pragmas"

	aPragmaProcessor queue: aCollectionOfClasses; run.
	^ aPragmaProcessor asTower! !

!MooseModel class methodsFor: 'meta' stamp: 'simon.denier 4/17/2009 19:15'!
metaTower

	^metaTower ifNil: [
		metaTower := self metaBuilder: self metamodelClasses ]! !

!MooseModel class methodsFor: 'meta' stamp: 'simon.denier 4/17/2009 19:14'!
metamodelClasses

	^ MooseEntity withAllSubclasses! !

!MooseModel class methodsFor: 'private-instance creation' stamp: 'stephane.ducasse 1/20/2009 14:26'!
newWithDefaultModels 
	 
	| result | 
	result := self new. 
	(Pragma 
		allNamed: #defaultModel 
		in: self class) 
		do: [:pragma | result add: (self perform: pragma selector)]. 
	^result! !

!MooseModel class methodsFor: 'accessing' stamp: 'tg 5/17/2009 22:55'!
ownerOf: element 
	"Answer the MooseModel which includes element.   
 
	We used to store the owning model in an instance variable, but benchmarks 
	have shown that this solution is fast enought. With the new implementation, 
	MooseModel uses a dedicated data-structure to keep track of its element's 
	IDs, see DictionaryStorage>>computeRanges. The main bottleneck as of now 
	is the enumeration if all instances, hecne, as a work around, we keep 
	track of the most recent owner." 
	 
	| elementID | 
	elementID := element mooseID. 
	nil ~~ elementID 
		ifTrue: [nil ~~ MostRecentOwner 
					ifTrue: [(MostRecentOwner includesID: elementID) 
								ifTrue: [^MostRecentOwner]]. 
				self allInstancesDo: 
						[:model | (model includesID: elementID) ifTrue: [^MostRecentOwner := model]]]. 
	^nil! !

!MooseModel class methodsFor: 'meta' stamp: 'tg 9/4/2008 12:01'!
resetMeta
	"self resetMeta"

	metaTower := nil.
	^self meta
	! !

!MooseModel class methodsFor: 'root model' stamp: 'sd 5/6/2009 10:55'!
resetRoot

	rootModel := nil! !

!MooseModel class methodsFor: 'root model' stamp: 'simon.denier 7/30/2009 11:55'!
root 
	 
	^ rootModel 
		ifNil: 
			[ rootModel := (self new) 
				name: 'Root'; 
				yourself ]! !

!MooseModel methodsFor: 'entity collection' stamp: 'simondenier 4/9/2010 11:38'!
add: anElement 
	 
	super add: anElement. 
	anElement privateSetMooseModel: self.
	self announcer announce: (MooseEntityAdded new entity: anElement).
	^anElement! !

!MooseModel methodsFor: 'entity collection' stamp: 'TudorGirba 6/29/2011 22:25'!
add: aBookmarkedGroup asBookmark: aString
	 
	self privateState cacheAt: aString put: aBookmarkedGroup.
	self announcer announce: (MooseEntityAdded new entity: aBookmarkedGroup).
	^ aBookmarkedGroup! !

!MooseModel methodsFor: 'entity collection' stamp: ' 8/5/08 13:52'!
addAll: entities 
	 
	entities do: [:each | self add: each]. 
	^entities! !

!MooseModel methodsFor: 'accessing' stamp: 'TudorGirba 4/4/2011 10:33'!
allBookmarks
	<navigation: 'All bookmarks'>
	^ MooseGroup 
		withAll: (self entityCache select: [:group| group isBookmarked ])
		withDescription: 'Bookmarks'! !

!MooseModel methodsFor: 'accessing' stamp: 'TudorGirba 2/20/2011 19:07'!
allSourceLanguages
	| result |
	result := MooseGroup new.
	FAMIXSourceLanguage withAllSubclassesDo: [:each | 
		result addAll: (self allWithType: each) ].
	^ result! !

!MooseModel methodsFor: 'actions' stamp: 'tg 8/5/2009 11:37'!
asMSEString
	| stream |
	stream := (String new: 1024) writeStream.
	self exportToMSEStream: stream.
	^ stream contents! !

!MooseModel methodsFor: 'groups' stamp: 'TudorGirba 5/25/2011 12:10'!
cacheMooseGroups
	<menuItem: 'Cache groups' category: 'Utilities'>

	| selectors |
	self privateState flushGroups.
	selectors := self navigationSelectors.
	MooseCustomTask
		runWithProgress: [:bar|
			selectors do: [:sel|
				self perform: sel.
				bar increment]
			]
		description: ('Caching <1p> groups in Moose model' expandMacrosWith: selectors size)
		length: selectors size! !

!MooseModel methodsFor: 'set operations' stamp: 'tg 7/30/2009 23:48'!
difference: aGroup 
	 
	| result | 
	result := MooseGroup withAll: (self entities difference: aGroup entities). 
	result description: self description , '  subtracted with ' , aGroup description. 
	^result! !

!MooseModel methodsFor: 'actions' stamp: 'simon_denier 9/21/2009 22:32'!
exportToMSEStream: aStream 
	"Benchmarks on Network packages
		Time millisecondsToRun: [ self exportToMSEStream: (StandardFileStream forceNewFileNamed: 'network.mse') ]
		34408ms -> simon.denier 9/11/2009 11:12 - initial run
		35527ms -> simon.denier 9/11/2009 11:51 - IdentityHashSet in FMRepository#elements, worse?
		rewind
		32236ms -> simon.denier 9/11/2009 17:46 - IdentityHashTable in FMRepositoryVisitor, a bit better but not much
		30963ms -> simon.denier 9/15/2009 12:28 - cache for roots (UI process)
		24661ms -> simon_denier 9/21/2009 22:32 - removing metrics from MSE
	"
	self class 
		export: self
		to: aStream! !

!MooseModel methodsFor: 'actions' stamp: 'simon_denier 9/21/2009 22:34'!
importFromMSEStream: aStream 
	"Benchmarks
	Time millisecondsToRun: [ MooseModel new importFromMSEStream: (StandardFileStream readOnlyFileNamed: 'network3.mse') ].
	Time millisecondsToRun: [ MooseModel new importFromMSEStream: (StandardFileStream readOnlyFileNamed: 'moose.mse') ]. 178163 simon.denier 9/11/2009 12:29
	 23678 -> simon.denier 9/11/2009 11:36 - initial run
 	 21551 -> simon.denier 9/11/2009 12:18 - IdentityHashSet (reverted)
	 17560 -> simon_denier 9/21/2009 22:34 - removing metrics from MSE
	"
	| repository |
	repository := self class importFrom: aStream.
	repository elements do: [ :e | self add: e ].
	self entityStorage forRuntime! !

!MooseModel methodsFor: 'actions' stamp: 'cyrille.delaunay 11/19/2009 16:22'!
importFromMSEStream: aStream filteredBy: anImportingContext
	
	| repository |
	repository := self class importFrom: aStream filteredBy: anImportingContext.
	repository elements do: [ :e | self add: e ].
	self entityStorage forRuntime! !

!MooseModel methodsFor: 'testing' stamp: 'tg 11/15/2009 22:47'!
includes: anItem 
	anItem isNil ifTrue: [^ false].
	^ self includesID: anItem mooseID! !

!MooseModel methodsFor: 'initialize-release' stamp: ' 8/5/08 13:52'!
initialize 
	 
	super initialize. 
	name := #noname! !

!MooseModel methodsFor: 'actions' stamp: 'simondenier 4/9/2010 10:48'!
install 

	^ self installWithCache: true! !

!MooseModel methodsFor: 'actions' stamp: 'simondenier 4/9/2010 10:48'!
installWithCache: aBoolean

	aBoolean
		ifTrue: [	self cacheMooseGroups ].
	^ MooseModel root add: self! !

!MooseModel methodsFor: 'set operations' stamp: 'tg 7/30/2009 23:48'!
intersect: aGroup 
	 
	| result | 
	result := MooseGroup withAll: (self entities intersection: aGroup entities). 
	result description: self description , '  intersected with ' , aGroup description. 
	^result! !

!MooseModel methodsFor: 'accessing' stamp: ' 8/5/08 13:52'!
localMooseModel 
	 
	^self! !

!MooseModel methodsFor: 'printing' stamp: 'tg 8/31/2010 10:23'!
mooseDisplayStringOn: stream
	stream 	nextPutAll: self name! !

!MooseModel methodsFor: 'accessing' stamp: ' 8/5/08 13:52'!
name 
	 
	^name! !

!MooseModel methodsFor: 'accessing' stamp: 'tg 12/18/2009 17:13'!
name: aStringOrSymbol
	| oldName |
	oldName := name.
	name := aStringOrSymbol.
	(oldName notNil and: [oldName ~= name]) ifTrue: [ 
		self announcer announce: (MooseEntityRenamed new oldName: oldName) ]! !

!MooseModel methodsFor: 'actions' stamp: 'simondenier 3/19/2010 14:07'!
remove

	^ MooseModel root remove: self! !

!MooseModel methodsFor: 'entity collection' stamp: 'tg 4/28/2010 18:17'!
remove: anElement
	self entityStorage remove: anElement. 
	anElement privateSetMooseModel: nil. 
	self privateState flushGroups. 
	self announcer announce: (MooseEntityRemoved new entity: anElement).
	^anElement! !

!MooseModel methodsFor: 'entity collection' stamp: 'tg 7/30/2009 21:03'!
removeAll: collection 
	 collection do: [:each | self remove: each]. ! !

!MooseModel methodsFor: 'entity collection' stamp: 'sd 5/5/2009 18:36'!
removeModelNamed: aStringOrSymbol

	| el |
	el := self entityStorage elements detect: [:each | each name = aStringOrSymbol asSymbol] ifNone: [nil].
	el ifNotNil: [self entityStorage remove: el.
				el privateSetMooseModel: nil.].
	^el! !

!MooseModel methodsFor: 'accessing' stamp: 'cyrille.delaunay 4/30/2010 15:53'!
rootFolder

	^ self privateState 	attributeAt: #rootFolder 
							ifAbsent: [	FileDirectory default fullName,
											FileDirectory slash,
											'src',
											FileDirectory slash,
											self name,
											FileDirectory slash ]! !

!MooseModel methodsFor: 'accessing' stamp: 'cyrille.delaunay 4/30/2010 15:53'!
rootFolder: aString

	| rootName |
	rootName := (aString at: aString size) = FileDirectory pathNameDelimiter
					ifTrue: [ aString ]
					ifFalse: [ aString, FileDirectory pathNameDelimiter asString ].
	^ self privateState attributeAt: #rootFolder put: rootName! !

!MooseModel methodsFor: 'entity collection' stamp: 'FabrizioPerin 11/24/2011 15:34'!
silentlyAdd: anElement 
	 
	self suspendAllAnnouncementsDuring: [^self add: anElement].! !

!MooseModel methodsFor: 'entity collection' stamp: 'FabrizioPerin 11/24/2011 14:07'!
silentlyAddAll: entities 
	 
	entities do: [:each | self silentlyAdd: each].
	^entities! !

!MooseModel methodsFor: 'entity collection' stamp: 'FabrizioPerin 11/24/2011 15:35'!
silentlyRemove: anElement 
	
	self suspendAllAnnouncementsDuring: [^self remove: anElement].! !

!MooseModel methodsFor: 'entity collection' stamp: 'FabrizioPerin 11/24/2011 15:35'!
silentlyRemoveAll: collection 
	
	collection do: [:each | self silentlyRemove: each].
	^collection
	! !

!MooseModel methodsFor: 'accessing' stamp: 'tg 8/5/2009 12:40'!
size
	^ self entityStorage size! !

!MooseModel methodsFor: 'accessing' stamp: 'TudorGirba 4/4/2011 01:02'!
sourceLanguage
	<MSEProperty: #sourceLanguage type: #FAMIXSourceLanguage>
	^sourceLanguage ifNil: [
		self allSourceLanguages 
			detect: [:each | each isAttached not]
			ifNone: [FAMIXUnknownSourceLanguage new]]! !

!MooseModel methodsFor: 'accessing' stamp: 'tg 8/5/2009 12:40'!
sourceLanguage: aSymbol
	^sourceLanguage := aSymbol! !

!MooseModel methodsFor: 'set operations' stamp: 'tg 7/30/2009 23:47'!
union: aGroup 
	 
	| result | 
	result := MooseGroup withAll: (self entities asSet union: aGroup entities asSet). 
	result description: self description , '  and ' , aGroup description. 
	^result! !

!MooseEntity class methodsFor: 'meta' stamp: 'tg 8/10/2010 15:53'!
annotation
	<MSEClass: #Entity super: #Object>
	<package: #Moose>
	<abstract>! !

!MooseEntity class methodsFor: 'private' stamp: 'janniklaval 9/23/2011 13:55'!
freshID 
	"Answer a fresh ID, which is unique within Moose." 
	 
	nil == MooseID ifTrue: [MooseID := 0]. 
	MooseID := 1 + MooseID. 
	MooseID > SmallInteger maxVal
		ifTrue: 
			[Notification 
				signal: 
					('Moose''s internal element IDs are exceeding the range of SmallInteger, ' 
						, 
							'this may cause system slow down.<n> Please contact <1s> for more information.' 
						expandMacrosWith: self mooseDev)]. 
	^MooseID! !

!MooseEntity class methodsFor: 'constants' stamp: 'janniklaval 9/23/2011 13:55'!
mooseDev 
	"Answer the email address of the Moose mailinglist." 
	 
	^'moose-dev@iam.unibe.ch'! !

!MooseEntity class methodsFor: 'private' stamp: 'janniklaval 9/23/2011 13:55'!
resetIDGeneration 
	"Resets the internal ID generation." 
	 
	MooseID := nil! !

!MooseEntity class methodsFor: 'private' stamp: 'janniklaval 9/23/2011 13:56'!
setMooseID: anInteger
	"This method is used in the unit test"
	
	MooseID := anInteger ! !

!MooseEntity methodsFor: 'meta information' stamp: 'simon.denier 9/21/2009 14:59'!
allDeclaredProperties
	"All properties described in the metamodel"
	 
	^self mooseDescription allAttributes! !

!MooseEntity methodsFor: 'meta information' stamp: 'janniklaval 9/23/2011 16:27'!
allPropertySelectors
	"Return a dictionary with all properties of the entity, including metamodel properties, metrics, and navigation groups. Keys are abstract names of properties, values are implementing selectors"
	
	| props |
	props := IdentityDictionary new.
	self allDeclaredProperties do: [:prop | props at: prop name put: prop implementingSelector].
	(Pragma allNamed: #navigation: from: self class to: MooseEntity)
		do: [:p | props at: p selector put: p selector].
	(Pragma allNamed: #'property:longName:description:' from: self class to: MooseEntity)
		do: [:p | props at: (p argumentAt: 1) put: p selector].
	^ props! !

!MooseEntity methodsFor: 'private' stamp: 'cyrille.delaunay 4/30/2010 15:54'!
announcer
	^ self privateState attributeAt: #announcer ifAbsentPut: [Announcer new]! !

!MooseEntity methodsFor: 'private' stamp: 'TudorGirba 11/23/2011 14:10'!
announcer: anAnnouncer
	^ self privateState attributeAt: #announcer put: anAnnouncer! !

!MooseEntity methodsFor: 'accessing' stamp: 'TudorGirba 6/29/2011 22:24'!
bookmarkAs: aString
	"Adds myself in the cache of the mooseModel and mark it as a bookmark"
	| group |
	group := self asMooseGroup description: aString.
	group isBookmarked: true.
	^ self mooseModel add: group asBookmark: aString! !

!MooseEntity methodsFor: 'accessing' stamp: ' 8/5/08 13:52'!
children 
	 
	| selectors children | 
	selectors := self class selectors select: [:each | 'all*s' match: each]. 
	children := OrderedCollection new. 
	selectors 
		do: 
			[:eachSelector |  
			| group | 
			group := self perform: eachSelector. 
			group isEmpty ifFalse: [children add: group]]. 
	^children! !

!MooseEntity methodsFor: 'private' stamp: 'TudorGirba 2/11/2011 23:54'!
defaultStateClass 
	"Answer the default implementator of this element's state." 
	 
	^MooseDefaultState! !

!MooseEntity methodsFor: 'accessing' stamp: ' 8/5/08 13:52'!
description 
	 
	^self privateState description! !

!MooseEntity methodsFor: 'accessing' stamp: ' 8/5/08 13:52'!
description: characters 
	 
	self privateState description: characters! !

!MooseEntity methodsFor: 'groups' stamp: 'AlexandreBergel 3/5/2011 23:29'!
entityCache 
	 
	"should be used read only, i.e. you are not supposed to modify the returned groups.
	If you want to change entityGroups, use privateState 'set' methods"
	^self privateState entityCache! !

!MooseEntity methodsFor: 'groups' stamp: 'AlexandreBergel 3/22/2011 21:20'!
groupFor: aSelector
	"Return a group containing elements corresponding to aSelector"
	"aSelector = allPackages, allClasses, allMethods, ... "

	| res groupName |
	res := self perform: aSelector.
	groupName := aSelector asString capitalized, ' in ', self mooseName.
	^ res isCollection
			ifTrue: [ MooseGroup withAll: res withDescription: groupName ]
			ifFalse: [ MooseGroup with: res withDescription: groupName ]
! !

!MooseEntity methodsFor: 'properties' stamp: 'TudorGirba 4/3/2011 09:21'!
handleFameProperty: aSymbol value: anObject
	
	| value |
	value := (anObject isCollection and: [anObject size = 1]) ifTrue: [anObject anyOne] ifFalse: [anObject].
	self propertyNamed: aSymbol put: value! !

!MooseEntity methodsFor: 'properties' stamp: 'TudorGirba 7/15/2011 19:25'!
hasTheSamePropertiesAs: aMooseEntity
	"Returns whether the receiver and the argument have the same properties (attributes and properties)."

	self allDeclaredProperties size = aMooseEntity allDeclaredProperties size 
		ifFalse: [^ false].
	(self allDeclaredProperties collect: [:each | each name]) = 
		(aMooseEntity allDeclaredProperties collect: [:each | each name])
		ifFalse: [^ false].
	self allDeclaredProperties do: [:each |
			(each getFrom: self) = (each getFrom: aMooseEntity)
				ifFalse: [^ false]
				].
	^ true! !

!MooseEntity methodsFor: 'initialization' stamp: 'janniklaval 9/23/2011 13:54'!
initialize 
	 
	super initialize. 
	mooseID := MooseModel freshID.
	state := self defaultStateClass with: self! !

!MooseEntity methodsFor: 'accessing' stamp: 'TudorGirba 4/4/2011 10:32'!
isBookmarked
	^ self propertyNamed: #isBookmarked ifNil: [false]! !

!MooseEntity methodsFor: 'accessing' stamp: 'TudorGirba 4/4/2011 10:32'!
isBookmarked: aBoolean
	self propertyNamed: #isBookmarked put: aBoolean! !

!MooseEntity methodsFor: 'testing' stamp: 'tg 7/10/2010 16:32'!
isStub 
	^ self privateState isStub! !

!MooseEntity methodsFor: 'accessing' stamp: ' 8/5/08 13:52'!
localMooseModel 
	 
	^self mooseModel! !

!MooseEntity methodsFor: 'properties' stamp: ' 8/5/08 13:52'!
lookUpPropertyNamed: selector computedAs: aBlock 
	 
	^self privateState cache: selector initializer: aBlock! !

!MooseEntity methodsFor: 'printing' stamp: 'TudorGirba 9/25/2011 14:25'!
mooseDisplayStringOn: stream
	self mooseNameOn: stream! !

!MooseEntity methodsFor: 'accessing' stamp: 'janniklaval 9/23/2011 13:50'!
mooseID 
	"Returns an unique identifier of this entity.  This method is mandatory, and must 
	return	an Integer that unqiuely identifies this entity within the entire Moose environ- 
	ment. The return value must not be nil, and must never change." 
	 
	"nil = mooseID ifTrue: [mooseID := MooseModel freshID]." 
	^mooseID! !

!MooseEntity methodsFor: 'accessing' stamp: 'TudorGirba 2/11/2011 23:12'!
mooseModel
	"Answers the model containing the current entity"
	^ self privateState model! !

!MooseEntity methodsFor: 'accessing' stamp: ' 8/5/08 13:52'!
mooseModel: aMooseModel 
	 
	aMooseModel add: self. 
	self privateState model: aMooseModel! !

!MooseEntity methodsFor: 'printing' stamp: 'TudorGirba 10/30/2011 21:51'!
mooseName
	"The return value must not be nil, and must never change.
	The implementation should be fast, as this key may be used
	extensively by MooseGroup or similar facilities.
	
	Do not override this method.
	Instead, use mooseNameOn: to customize the result."

	| stream |
	^ self privateState 
		propertyAt: #mooseName
		ifAbsentPut: 
			[ stream := (String new: 64) writeStream.
			self mooseNameOn: stream.
			^ stream contents asSymbol ]! !

!MooseEntity methodsFor: 'printing' stamp: 'StephaneDucasse 10/30/2011 23:09'!
mooseNameOn: aStream 
	"Hook to customize the rendered text of an entity. Do not specialize mooseName, but change/specialize this method if necessary."
	self mooseID isNil 
		ifTrue: [ aStream nextPutAll: 'nil mooseID!!!!!!' ]
		ifFalse: 
			[ self name 
				ifNil: [ aStream print: self mooseID ]
				ifNotNil: [ aStream nextPutAll: self name ] ]! !

!MooseEntity methodsFor: 'accessing' stamp: ' 8/5/08 13:52'!
name 
	 
	^#noname! !

!MooseEntity methodsFor: 'meta information' stamp: 'janniklaval 9/23/2011 16:28'!
navigationSelectors

	^ (Pragma allNamed: #navigation: from: self class to: MooseEntity)
					collect: [:p | p selector]! !

!MooseEntity methodsFor: 'properties' stamp: ' 22/6/08 19:32'!
notExistentMetricValue
	
	^-1! !

!MooseEntity methodsFor: 'printing' stamp: 'janniklaval 9/23/2011 13:55'!
printOn: aStream 
	 
	super printOn: aStream. 
	aStream space 
		print: 
			([self mooseName] 
				on: Error 
				do: ['Error printing the object'])! !

!MooseEntity methodsFor: 'private' stamp: ' 8/5/08 13:52'!
privateSetMooseModel: aMooseModel 
	 
	self privateState model: aMooseModel! !

!MooseEntity methodsFor: 'private' stamp: 'stephane.ducasse 5/23/2008 16:09'!
privateState

	^ state! !

!MooseEntity methodsFor: 'private' stamp: 'stephane.ducasse 10/28/2008 22:51'!
privateState: aState

	state := aState.
	aState entity: self.! !

!MooseEntity methodsFor: 'private' stamp: 'cyrille.delaunay 4/30/2010 15:32'!
properties 
	 
	"for read only uses, i.e. don't change he returned value"
	
	^self privateState allProperties! !

!MooseEntity methodsFor: 'properties' stamp: 'simon.denier 3/30/2009 20:19'!
propertyNamed: propertyName 
	"Return the value of the property named propertyName, return nil if the property does not exist"

	^ self propertyNamed: propertyName ifNil: [ nil ]
! !

!MooseEntity methodsFor: 'properties' stamp: 'cyrille.delaunay 4/30/2010 15:51'!
propertyNamed: name ifAbsentPut: value 
	 
	^self privateState propertyAt: name ifAbsentPut: value! !

!MooseEntity methodsFor: 'properties' stamp: 'TudorGirba 10/30/2011 22:34'!
propertyNamed: propertyName ifNil: aBlock 
	"Return the value of the property named propertyName, evaluate aBlock if the property does not exist" 
	 
	| prop |
	prop := propertyName asSymbol.
	^ self privateState 
		propertyAt: prop
		ifAbsent: 
			[ | property |
			[ property := self mmGetProperty: 
				(self mooseDescription attributeNamed: propertyName) ]
				on: Error
				do: [ :ex | property := nil ].
			property ifNil: [aBlock value] ].
! !

!MooseEntity methodsFor: 'properties' stamp: 'cyrille.delaunay 4/30/2010 15:51'!
propertyNamed: name put: value 
	 
	^self privateState propertyAt: name put: value! !

!MooseEntity methodsFor: 'accessing' stamp: ' 8/5/08 13:52'!
removeFromModel 
	 
	^self mooseModel isNil 
		ifTrue: [self] 
		ifFalse: [self mooseModel removeEntity: self]! !

!MooseEntity methodsFor: 'private' stamp: 'TudorGirba 11/23/2011 14:08'!
suspendAllAnnouncementsDuring: aBlock
	| currentAnnouncer |	
	currentAnnouncer := self announcer.
	[ 	self announcer: Announcer new.
		aBlock value ]
			ensure: [ self announcer: currentAnnouncer ]! !

Object subclass: #MooseEntityState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-Core'!

!MooseEntityState commentStamp: 'tg 5/8/2008 15:45' prior: 0!
I represent the state of an entity.
My main methods are:

	!

MooseEntityState subclass: #MooseDefaultState
	instanceVariableNames: 'attributes entity propertyCache queryCache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-Core'!

!MooseDefaultState methodsFor: 'accessing properties' stamp: 'cyrille.delaunay 4/27/2010 13:05'!
allProperties 
	 
	^propertyCache values! !

!MooseDefaultState methodsFor: 'accessing attributes' stamp: 'cyrille.delaunay 4/30/2010 15:53'!
attributeAt: name ifAbsent: aBlock 
	 
	| each | 
	1 
		to: attributes size 
		do: 
			[:n |  
			each := attributes at: n. 
			name == each key ifTrue: [^each value]]. 
	^aBlock value! !

!MooseDefaultState methodsFor: 'accessing attributes' stamp: 'cyrille.delaunay 4/30/2010 15:54'!
attributeAt: name ifAbsentPut: aBlock 
	 
	| each | 
	1 
		to: attributes size 
		do: 
			[:n |  
			each := attributes at: n. 
			name == each key ifTrue: [
				^each value]]. 
	attributes := attributes copyWith: name -> aBlock value. 
	^attributes last value! !

!MooseDefaultState methodsFor: 'accessing attributes' stamp: 'cyrille.delaunay 4/30/2010 15:53'!
attributeAt: name put: value 
	 
	| each | 
	1 
		to: attributes size 
		do: 
			[:n |  
			each := attributes at: n. 
			name == each key ifTrue: [^each value: value]]. 
	attributes := attributes copyWith: name -> value. 
	^attributes last value! !

!MooseDefaultState methodsFor: 'accessing groups' stamp: 'cyrille.delaunay 4/30/2010 15:47'!
cacheAt: name ifAbsent: aBlock 
	 
	^ queryCache at: name ifAbsent: [aBlock value].
	"| each | 
	1 
		to: queryCache size 
		do: 
			[:n |  
			each := queryCache at: n. 
			name == each key ifTrue: [^each value]]. 
	^aBlock value"! !

!MooseDefaultState methodsFor: 'accessing groups' stamp: 'cyrille.delaunay 5/4/2010 13:00'!
cacheAt: name ifAbsentPut: aBlock 

	^ queryCache at: name ifAbsentPut: aBlock.
	"| each | 
	1 
		to: queryCache size 
		do: 
			[:n |  
			each := queryCache at: n. 
			name == each key ifTrue: [
				^each value]]. 
	queryCache := queryCache copyWith: name -> aBlock value. 
	^queryCache last value"! !

!MooseDefaultState methodsFor: 'accessing groups' stamp: 'cyrille.delaunay 4/30/2010 15:47'!
cacheAt: name put: value 
	 
	^ queryCache at: name put: value.
	"| each | 
	1 
		to: queryCache  size 
		do: 
			[:n |  
			each := queryCache at: n. 
			name == each key ifTrue: [^each value: value]]. 
	queryCache := queryCache copyWith: name -> value. 
	^queryCache last value"! !

!MooseDefaultState methodsFor: 'accessing' stamp: 'stephane.ducasse 10/28/2008 22:51'!
entity

	^ entity! !

!MooseDefaultState methodsFor: 'accessing' stamp: 'stephane.ducasse 10/28/2008 22:52'!
entity: anObject

	entity := anObject! !

!MooseDefaultState methodsFor: 'accessing groups' stamp: 'cyrille.delaunay 4/30/2010 15:50'!
entityCache 
	 
	^queryCache! !

!MooseDefaultState methodsFor: 'controlling' stamp: 'cyrille.delaunay 4/27/2010 13:05'!
flushGroups 
	 
	queryCache initialize! !

!MooseDefaultState methodsFor: 'controlling' stamp: 'cyrille.delaunay 4/27/2010 13:05'!
flushProperties 
	 
	propertyCache initialize! !

!MooseDefaultState methodsFor: 'testing' stamp: 'cyrille.delaunay 4/27/2010 13:05'!
includesKey: selector 
	 
	^propertyCache includesKey: selector! !

!MooseDefaultState methodsFor: 'initialize-release' stamp: 'cyrille.delaunay 4/27/2010 13:05'!
initialize: aMooseEntity 
	 
	attributes := #(). 
	propertyCache := SmallDictionary new. 
	queryCache := SmallDictionary new.
	entity := aMooseEntity! !

!MooseDefaultState methodsFor: 'accessing properties' stamp: 'cyrille.delaunay 4/30/2010 15:51'!
propertyAt: name ifAbsent: aBlock 
	 
	^ propertyCache  at: name ifAbsent: [aBlock value].
! !

!MooseDefaultState methodsFor: 'accessing properties' stamp: 'cyrille.delaunay 5/4/2010 13:01'!
propertyAt: name ifAbsentPut: aBlock 
	 
	^ propertyCache  at: name ifAbsentPut: aBlock.
! !

!MooseDefaultState methodsFor: 'accessing properties' stamp: 'cyrille.delaunay 4/30/2010 15:51'!
propertyAt: name put: value 
	 
	^ propertyCache  at: name put: value.
! !

!MooseEntityState class methodsFor: 'instance creation' stamp: 'janniklaval 9/23/2011 14:20'!
with: aMooseEntity
	 
	^self new initialize: aMooseEntity! !

!MooseEntityState methodsFor: 'accessing-properties' stamp: 'cyrille.delaunay 4/30/2010 15:32'!
allProperties 
	 
	"for read only uses, i.e. don't change he returned value"
	self subclassResponsibility! !

!MooseEntityState methodsFor: 'accessing-attributes' stamp: 'cyrille.delaunay 4/30/2010 15:53'!
attributeAt: name ifAbsent: aBlock 
	 
	self subclassResponsibility! !

!MooseEntityState methodsFor: 'accessing-attributes' stamp: 'cyrille.delaunay 4/30/2010 15:54'!
attributeAt: name ifAbsentPut: aBlock 
	 
	self subclassResponsibility! !

!MooseEntityState methodsFor: 'accessing-attributes' stamp: 'cyrille.delaunay 4/30/2010 15:53'!
attributeAt: name put: value 
	 
	self subclassResponsibility! !

!MooseEntityState methodsFor: 'accessing-properties' stamp: 'cyrille.delaunay 4/30/2010 15:51'!
cache: selector initializer: aBlock 
	 
	^self 
		propertyAt: selector 
		ifAbsentPut: [aBlock cullValue: self entity]! !

!MooseEntityState methodsFor: 'accessing group' stamp: 'cyrille.delaunay 4/30/2010 15:47'!
cacheAt: name ifAbsent: aBlock

	self subclassResponsibility ! !

!MooseEntityState methodsFor: 'accessing group' stamp: 'cyrille.delaunay 4/30/2010 15:49'!
cacheAt: name ifAbsentPut: aBlock

	self subclassResponsibility ! !

!MooseEntityState methodsFor: 'accessing group' stamp: 'cyrille.delaunay 4/30/2010 15:47'!
cacheAt: name put: value

	self subclassResponsibility ! !

!MooseEntityState methodsFor: 'initialize-release' stamp: ' 8/5/08 13:52'!
clone: newOwner 
	 
	| newState | 
	newState := self copy. 
	newState initialize: newOwner. 
	newState model: nil. 
	^newState! !

!MooseEntityState methodsFor: 'accessing-common attributes' stamp: 'cyrille.delaunay 4/30/2010 15:53'!
description 
	 
	| entity | 
	^self 
		attributeAt: #privateDescription 
		ifAbsent: 
			[entity := self entity. 
			entity mooseName , ' (' , entity mooseDescription name , ')']! !

!MooseEntityState methodsFor: 'accessing-common attributes' stamp: 'cyrille.delaunay 4/30/2010 15:53'!
description: text 
	 
	^self attributeAt: #privateDescription put: text! !

!MooseEntityState methodsFor: 'initialize-release' stamp: 'stephane.ducasse 10/28/2008 22:58'!
entity
	
	^ self subclassResponsibility! !

!MooseEntityState methodsFor: 'accessing' stamp: 'cyrille.delaunay 4/30/2010 15:50'!
entityCache 
	 
	self subclassResponsibility! !

!MooseEntityState methodsFor: 'controlling' stamp: ' 8/5/08 13:52'!
flush 
	 
	self flushProperties. 
	self flushGroups! !

!MooseEntityState methodsFor: 'controlling' stamp: ' 8/5/08 13:52'!
flushGroups 
	 
	self subclassResponsibility! !

!MooseEntityState methodsFor: 'controlling' stamp: ' 8/5/08 13:52'!
flushProperties 
	 
	self subclassResponsibility! !

!MooseEntityState methodsFor: 'testing' stamp: ' 8/5/08 13:52'!
includesKey: selector 
	 
	self subclassResponsibility! !

!MooseEntityState methodsFor: 'initialize-release' stamp: ' 8/5/08 13:52'!
initialize: aMooseEntity 
	 
	self subclassResponsibility! !

!MooseEntityState methodsFor: 'accessing-common attributes' stamp: 'cyrille.delaunay 4/30/2010 15:53'!
isStub 
	 
	^self 
		attributeAt: #privateIsStub 
		ifAbsent: [false]! !

!MooseEntityState methodsFor: 'accessing-common attributes' stamp: 'cyrille.delaunay 4/30/2010 15:53'!
isStub: boolean 
	 
	^self attributeAt: #privateIsStub put: boolean! !

!MooseEntityState methodsFor: 'accessing-common attributes' stamp: 'cyrille.delaunay 4/30/2010 15:53'!
model 
	 
	^self 
		attributeAt: #privateModel 
		ifAbsent: [MooseModel ownerOf: self entity]! !

!MooseEntityState methodsFor: 'accessing-common attributes' stamp: 'cyrille.delaunay 4/30/2010 15:53'!
model: anObject 
	 
	^self attributeAt: #privateModel put: anObject! !

!MooseEntityState methodsFor: 'accessing-properties' stamp: 'cyrille.delaunay 4/30/2010 15:51'!
propertyAt: name ifAbsent: aBlock 
	 
	self subclassResponsibility.! !

!MooseEntityState methodsFor: 'accessing-properties' stamp: 'cyrille.delaunay 4/30/2010 15:51'!
propertyAt: name ifAbsentPut: aBlock 
	 
	self subclassResponsibility.! !

!MooseEntityState methodsFor: 'accessing-properties' stamp: 'cyrille.delaunay 4/30/2010 15:51'!
propertyAt: name put: value
	 
	self subclassResponsibility.! !

MooseEntityState subclass: #MooseMinimalState
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-Core'!

MooseMinimalState class
	instanceVariableNames: 'singelton'!

!MooseMinimalState commentStamp: 'stephane.ducasse 10/28/2008 22:49' prior: 0!
Is a kind of NullPattern!

MooseMinimalState class
	instanceVariableNames: 'singelton'!

!MooseMinimalState class methodsFor: 'instance creation' stamp: ' 8/5/08 13:52'!
new 
	 
	^self uniqueInstance! !

!MooseMinimalState class methodsFor: 'instance creation' stamp: ' 8/5/08 13:52'!
uniqueInstance 
	 
	^singelton ifNil: [singelton := self basicNew]! !

!MooseMinimalState methodsFor: 'accessing' stamp: ' 8/5/08 13:52'!
allProperties 
	 
	^#()! !

!MooseMinimalState methodsFor: 'accessing' stamp: 'cyrille.delaunay 4/30/2010 15:53'!
attributeAt: name ifAbsent: aBlock 
	 
	^aBlock value! !

!MooseMinimalState methodsFor: 'accessing' stamp: 'cyrille.delaunay 4/30/2010 15:54'!
attributeAt: name ifAbsentPut: aBlock 
	 
	self nullStateError! !

!MooseMinimalState methodsFor: 'accessing' stamp: 'cyrille.delaunay 4/30/2010 15:53'!
attributeAt: name put: value 
	 
	self nullStateError! !

!MooseMinimalState methodsFor: 'accessing' stamp: 'cyrille.delaunay 4/30/2010 15:50'!
entityCache 
	 
	^self! !

!MooseMinimalState methodsFor: 'controlling' stamp: ' 8/5/08 13:52'!
flushGroups 
	"do nothing" 
	 
	! !

!MooseMinimalState methodsFor: 'controlling' stamp: ' 8/5/08 13:52'!
flushProperties 
	"do nothing" 
	 
	! !

!MooseMinimalState methodsFor: 'testing' stamp: ' 8/5/08 13:52'!
includesKey: selector 
	" *** This method was defined by SCG.Moose.EntityState as a subclass responsibility. 
	Replace its body with a proper implementation. *** " 
	 
	self error: 'Subclass responsibility stub not reimplemented'! !

!MooseMinimalState methodsFor: 'accessing' stamp: ' 8/5/08 13:52'!
initialize: aMooseEntity 
	"do nothing" 
	 
	! !

!MooseMinimalState methodsFor: 'accessing-common attributes' stamp: ' 8/5/08 13:52'!
isStub 
	 
	^false! !

!MooseMinimalState methodsFor: 'accessing-common attributes' stamp: ' 8/5/08 13:52'!
isStub: boolean 
	 
	[boolean == false] assert! !

!MooseMinimalState methodsFor: 'accessing-common attributes' stamp: ' 8/5/08 13:52'!
model: anObject 
	 
	! !

Object subclass: #MooseIcons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-Core'!

MooseIcons class
	instanceVariableNames: 'icons'!

MooseIcons class
	instanceVariableNames: 'icons'!

!MooseIcons class methodsFor: 'utils' stamp: 'tg 11/5/2010 21:07'!
icons
	^ icons ifNil: [icons := Dictionary new]! !

!MooseIcons class methodsFor: 'utils' stamp: 'TudorGirba 2/5/2011 23:23'!
importIcon
	"self importIcon"
	| wantedIcons |
	MooseIcons resetIcons.
	wantedIcons := #('mooseIcon').
	MooseScripts importIcons: wantedIcons fromFolder: 'icons' inClass: MooseIcons category: 'logo'! !

!MooseIcons class methodsFor: 'logo' stamp: 'TudorGirba 2/8/2011 15:13'!
mooseIcon
^ self icons
		at: #mooseIcon ifAbsentPut: [(Form
	extent: 16@16
	depth: 32
	fromArray: #( 16777215 16777215 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 16777215 16777215 16777215 16777215 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 16777215 16777215 16777215 16777215 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 16777215 16777215 16777215 16777215 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 16777215 16777215 16777215 16777215 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 16777215 16777215 16777215 16777215 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 4278220759 16777215 16777215 16777215 16777215 4278220759 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278220759 16777215 16777215 16777215 16777215 4278220759 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278220759 16777215 16777215 16777215 16777215 4278220759 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278220759 16777215 16777215 16777215 16777215 4278220759 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4294967295 4278220759 16777215 16777215 16777215 16777215 4278220759 4294967295 4294441725 4282029536 4282029536 4294441725 4294441725 4282029536 4282029536 4294441725 4294967295 4278220759 16777215 16777215 16777215 16777215 4278220759 4294967295 4289647602 4278220759 4278220759 4289647602 4289647602 4278220759 4278220759 4289647602 4294967295 4278220759 16777215 16777215 16777215 16777215 4278220759 4294967295 4287152108 4278220759 4278220759 4287152108 4287152108 4278220759 4278220759 4287152108 4294967295 4278220759 16777215 16777215 16777215 16777215 4278220759 4294967295 4286626795 4278220759 4278220759 4286626795 4286626795 4278220759 4278220759 4286626795 4294967295 4278220759 16777215 16777215 16777215 16777215 4278220759 4294967295 4286626795 4278220759 4278220759 4286626795 4286626795 4278220759 4278220759 4286626795 4294967295 4278220759 16777215 16777215 16777215 16777215 4278220759 4294967295 4286626795 4278220759 4278220759 4286626795 4286626795 4278220759 4278220759 4286626795 4294967295 4278220759 16777215 16777215)
	offset: 0@0)]! !

!MooseIcons class methodsFor: 'utils' stamp: 'tg 11/5/2010 22:00'!
resetIcons
	icons := nil! !

Object subclass: #MooseTask
	instanceVariableNames: 'progBar nb'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-Core'!

!MooseTask commentStamp: 'StephaneDucasse 11/8/2011 17:14' prior: 0!
MooseTask is an abstract class that define the basic protocol for a Task. Basically a task should define how to run by specifying it in its run method.
It can also specify setUp and tearDown actions!

MooseTask subclass: #MooseCustomTask
	instanceVariableNames: 'computation description length'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Moose-Core'!

!MooseCustomTask commentStamp: 'StephaneDucasse 11/8/2011 17:26' prior: 0!
MooseCustomTask is a task perform some computation specified as a block.

The main API is then

	with: aBlock description: aDescription length: aNumber
!

!MooseCustomTask class methodsFor: 'instance creation' stamp: 'tg 12/1/2009 03:52'!
runWithProgress: aBlock description: aDescription length: aNumber
	^ self new 
		with: aBlock description: aDescription length: aNumber; 
		runWithProgress;
		yourself! !

!MooseCustomTask methodsFor: 'private' stamp: 'tg 12/1/2009 03:23'!
basicRun
	computation value: self! !

!MooseCustomTask methodsFor: 'accessing' stamp: 'tg 12/1/2009 03:22'!
description
	^ description! !

!MooseCustomTask methodsFor: 'accessing' stamp: 'tg 12/1/2009 03:22'!
length
	^ length! !

!MooseCustomTask methodsFor: 'initialize-release' stamp: 'tg 12/1/2009 03:22'!
with: aBlock description: aDescription length: aNumber
	computation := aBlock.
	description := aDescription.
	length := aNumber! !

!MooseTask methodsFor: 'private' stamp: ' 8/5/08 13:52'!
basicRun 
	 
	^self subclassResponsibility! !

!MooseTask methodsFor: 'accessing' stamp: ' 8/5/08 13:52'!
description 
	 
	^self subclassResponsibility! !

!MooseTask methodsFor: 'private' stamp: 'simon.denier 5/20/2009 14:02'!
increment 
	 
	progBar ifNotNil: [	nb := nb + 1. progBar value: nb]! !

!MooseTask methodsFor: 'accessing' stamp: ' 8/5/08 13:52'!
length 
	 
	^self subclassResponsibility! !

!MooseTask methodsFor: 'running' stamp: 'simon.denier 5/20/2009 12:55'!
profile 
	 
	^ TimeProfileBrowser spyOn: [self run]! !

!MooseTask methodsFor: 'running' stamp: 'simon.denier 5/20/2009 16:32'!
run 
	 
	| result | 
	[self setUp. 
	result := self basicRun] ensure: [self tearDown]. 
	^result! !

!MooseTask methodsFor: 'running' stamp: 'simon.denier 5/20/2009 16:15'!
runSelector: aSelector
	"Hack to let tasks decide whether to run or runWithProgress (see CompositeTask)"
	
	^ self perform: aSelector! !

!MooseTask methodsFor: 'running' stamp: 'TudorGirba 6/28/2011 10:39'!
runWithProfiler 
	Smalltalk isInteractive 
		ifTrue: [self profile]
		ifFalse: [self run]! !

!MooseTask methodsFor: 'running' stamp: 'simon.denier 5/20/2009 15:52'!
runWithProgress 
	 
	| result | 
	[self setUp. 
	nb := 0.
	UIManager default
		displayProgress: self description
		at: Sensor cursorPoint
		from: 1 
		to: self length 
		during: [ :bar | progBar := bar. result := self basicRun]]
			 ensure: [self tearDown]. 
	^result! !

!MooseTask methodsFor: 'private' stamp: ' 8/5/08 13:52'!
setUp 
	 
	! !

!MooseTask methodsFor: 'private' stamp: ' 8/5/08 13:52'!
tearDown 
	 
	! !

!Object methodsFor: '*moose-core' stamp: 'tg 5/18/2010 20:10'!
asMooseGroup 
	^ MooseGroup with: self! !

!Object methodsFor: '*moose-core' stamp: 'tg 5/25/2009 23:38'!
mooseDescription
	^ self class asMooseDescription! !

!Object methodsFor: '*moose-core' stamp: 'tg 8/8/2010 20:09'!
mooseDisplayString
	^ String streamContents: [:stream | self mooseDisplayStringOn: stream] ! !

!Object methodsFor: '*moose-core' stamp: 'tg 8/8/2010 20:10'!
mooseDisplayStringOn: aStream
	^ self printOn: aStream! !

!Object methodsFor: '*moose-core' stamp: 'tg 7/12/2010 22:29'!
mooseMenu
	| menu pragmas submenus |
	menu := MenuMorph new.
	submenus := SmallDictionary new.
	pragmas := SmallDictionary new.

	"if multiple pragmas are declared for the same selector at different level of the hierarchy, 
	we only pick the bottom one (as picked by the dynamic lookup)"	
	self class withAllSuperclasses do: [ :eachClass | 
		(Pragma 
			allNamed: #menuItem:category:
			in: eachClass) do: [ :eachPragma | 
				pragmas at: eachPragma selector ifAbsentPut: [ eachPragma ].
				submenus at: (eachPragma argumentAt: 2) ifAbsentPut: [ MenuMorph new ]].
		(Pragma 
			allNamed: #menuItem:
			in: eachClass) do: [ :eachPragma | 
				pragmas at: eachPragma selector ifAbsentPut: [ eachPragma ]]
	].

	submenus keysAndValuesDo:  [:cat :smenu |
		menu add: cat asString subMenu: smenu ].
	(pragmas values asSortedCollection: [:a :b| a selector < b selector]) do: [ :eachPragma |
		(eachPragma arguments size = 2 )
			ifTrue: [ "Submenu item"
				(submenus at: (eachPragma argumentAt: 2))
					add: (eachPragma argumentAt: 1)
					target: [ self perform: eachPragma selector ]
					selector: #value 				
				]
			ifFalse: [ "Top level item"
				menu 
					add: (eachPragma argumentAt: 1)
					target: [ self perform: eachPragma selector ]
					selector: #value ]].
	^ menu! !

!Object methodsFor: '*moose-core' stamp: 'simon.denier 9/18/2009 17:39'!
mooseMenuMorph
	| menu pragmas submenus |
	menu := MenuMorph new.
	submenus := SmallDictionary new.
	pragmas := SmallDictionary new.

	"if multiple pragmas are declared for the same selector at different level of the hierarchy, 
	we only pick the bottom one (as picked by the dynamic lookup)"	
	self class withAllSuperclasses do: [ :eachClass | 
		(Pragma 
			allNamed: #menuItem:category:
			in: eachClass) do: [ :eachPragma | 
				pragmas at: eachPragma selector ifAbsentPut: [ eachPragma ].
				submenus at: (eachPragma argumentAt: 2) ifAbsentPut: [ MenuMorph new ]].
		(Pragma 
			allNamed: #menuItem:
			in: eachClass) do: [ :eachPragma | 
				pragmas at: eachPragma selector ifAbsentPut: [ eachPragma ]]
	].

	submenus keysAndValuesDo:  [:cat :smenu |
		menu add: cat asString subMenu: smenu ].
	(pragmas values asSortedCollection: [:a :b| a selector < b selector]) do: [ :eachPragma |
		(eachPragma arguments size = 2 )
			ifTrue: [ "Submenu item"
				(submenus at: (eachPragma argumentAt: 2))
					add: (eachPragma argumentAt: 1)
					target: [ self perform: eachPragma selector ]
					selector: #value 				
				]
			ifFalse: [ "Top level item"
				menu 
					add: (eachPragma argumentAt: 1)
					target: [ self perform: eachPragma selector ]
					selector: #value ]].
	^ menu! !

!Object methodsFor: '*moose-core' stamp: 'tg 8/6/2009 21:40'!
mooseName
	^ self printString! !

!ClassDescription methodsFor: '*Moose-Core' stamp: 'stephane.ducasse 10/10/2008 16:15'!
@ aSymbol
	"TheRoot@#TheRootSharedVariable"
	"TheRoot class@#uniqueInstance"
	
	^ ((aSymbol first isUppercase
		ifTrue: [self instanceSide]
		ifFalse: [self]) mooseName, '.', aSymbol ) asSymbol! !

!ClassDescription methodsFor: '*moose-core' stamp: 'Alexandre.Bergel 3/27/2009 20:47'!
asMooseDescription

	^MooseModel meta descriptionOf: self theNonMetaClass ! !
